<?php
/**
 *
 * @package BookLibraryManager
 * @copyright 2012 Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru);Rob de Cleen(rob@decleen.com)
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary ShopPro
 *
 * */
defined('_JEXEC') or die;

$mosConfig_absolute_path = $GLOBALS['mosConfig_absolute_path'] = JPATH_SITE;
require_once ($mosConfig_absolute_path . "/components/com_booklibrary/compat.joomla1.5.php");
require_once ($mosConfig_absolute_path . "/components/com_booklibrary/booklibrary.class.sefurl.php");

//$GLOBALS['pu_debug'] = true;
function pu_log($msg, $request=false ) {

    global $pu_debug;

    if($pu_debug){
              // Write out new initialization file
        $logFilePath =  "./log_debug.log" ;
        $fd = fopen($logFilePath, "a+")
                or die("Cannot create log_debug.log file.");
        if(!empty($msg) ){
          fwrite($fd, "---------------".date( "d M Y G:i:s" ) ."\n");
          fwrite($fd, $msg ."\n" );
        } 
        if($request){
          if(is_string( $request ) || is_int( $request ) )  fwrite($fd,  $request ."\n" );
          else if(is_array( $request ) || is_object( $request ) ) 
            foreach($request as $key=>$value){
                if(is_string( $value ) || is_int( $value ) ) 
                    fwrite($fd,  "[".$key."] = ".$value ."\n" );
                else if(is_array( $value ) || is_object( $value ) ) {
                    fwrite($fd,  "[".$key."] = ".pu_log("",$value) ."\n" );
                }
            }
        }
        fclose($fd);    
      }
}


class booklibraryRouter extends JComponentRouterView
{
    public function build(&$query)
    {

        pu_log("booklibraryRouter:build start:",$query);
//        exit;


        $segments = array();
        $segments_with_id = array(); //need if same $segments exist for other URL(same book name or same author name.. )
        if (isset($query['view']))   $view =$query['view'] ;
        if (isset($query['task']))   $task =$query['task'] ;
        else if(isset($query['view']))  $task =$query['view'] ;


        if (isset($query['Itemid']) ) { 
            //for menu items - not use router

            if(!isset($task)) return $segments;

            if (isset($query['view']) ) { 

                $url_alias = get_menu_url_alias_bl($query['Itemid'],$task,$query['view']) ;
                if(!empty($url_alias) ) {
            pu_log("booklibraryRouter:build 001:",$query);        
                    if ( !isset($query['letindex']) 
                        && !isset($query['limitstart'])
                        && !isset($query['limit'])
                        )  {
                        // foreach ($query as $key => $value) {
                        //     if( $key == 'option' ) continue ;
                        //     if( $key == 'Itemid' ) continue ;
                        //     unset($query[$key]);
                        // }
                        unset($query['view']);
                        unset($query['layout']);
                    
            pu_log("booklibraryRouter:build 002:",$query);        
                        return $segments;
                    }

                }
            }
        }

        $db = JFactory::getDBO();

        // remove 'Itemid' from "vars query" for DB, because start menu items may be many
        $query_tmp = array();
        foreach ($query as $key => $value) {
            if( $key == 'Itemid' ) continue ;
            $query_tmp[$key] = $query[$key];
        }

        $sefurl = new mosSefurl($db);
        $ser_vars = serialize($query_tmp) ;
    pu_log("booklibraryRouter:build 01:",$query);        
        $hash_vars = md5( $ser_vars );
    pu_log("booklibraryRouter:build 011:",$ser_vars);        
        $sefurl = $sefurl->loadByHashVars($hash_vars);
    pu_log("booklibraryRouter:build 012:",$hash_vars);        
        if($sefurl != null ) {
            foreach ($query as $key => $value) {
                if( $key == 'option' ) continue ;
                if( $key == 'Itemid' ) continue ;
                if( $key == 'task' || $key == 'id' 
                    || $key == 'letindex' || $key == 'limitstart' || $key == 'limit' ||
                    ( $key == 'catid' && $task != "search") || 
                    ( $key == 'name' && $task == 'view_user_books') || 
                    ( $key == 'efileid' && $task == 'mdownload') 
                ) unset($query[$key] );
            }
            $segments = unserialize( $sefurl->ser_url_segments ) ;
    pu_log("booklibraryRouter:build 1:",$segments);
        //exit;

            return $segments;
        } else{
        pu_log("booklibraryRouter:build 2:");
            $sefurl = new mosSefurl($db);
            $sefurl->ser_vars = $ser_vars;
            $sefurl->hash_vars = $hash_vars ;

          
            if(isset($task)) {
                switch($task) {
                    case 'show_search':
                        $segments[] = 'show_search';
                    break;
                    case 'search':
                        $segments[] = 'search';
                    break;
                    case 'view':
                    case 'view_bl':
                        //$segments[] = 'view';
                    break;
                    case 'showCategory':
                    // $segments[] = "showCategory"; 
                    break;
                    case 'review':
                        $segments[] = 'review';
                    break;
                    case 'all_authors':
                        $segments[] = 'all_authors';
                    break; 
                    case 'owners_list':
                        $segments[] = 'owners_list';
                    break;    
                    case 'view_author':
                     //   $segments[] = 'view_author';
                    break;                        
                    case 'secret_image':
                     //   $segments[] = 'secret_image';
                    break;    

                    default:
                        $segments[] = JFilterOutput::stringURLUnicodeSLug($task);
                    break;
                }
            } 
            $s = getWhereUsergroupsString("c");

            if (isset($query['catid']) && $task != "search") {
                if( $query['catid'] > 0) {
                    $sql_query = "SELECT c.id, c.name, c.parent_id FROM #__booklibrary_main_categories AS c
                             \nWHERE ($s) AND c.id = ".intval($query['catid']);
                    $db->setQuery($sql_query);
                    $row = null;
                    $row = $db->loadObject();
                    
                    if(isset($row)) {
                      $cattitle = array();
                      $cattitle_with_id = array();
                      $cattitle[] = JFilterOutput::stringURLUnicodeSLug($row->name);
                      $cattitle_with_id[] = JFilterOutput::stringURLUnicodeSLug($row->id. '_' .$row->name);
                   
                      while(isset($row) && $row->parent_id>0) {
                        $sql_query = "SELECT name, c.id , parent_id 
                                  FROM #__booklibrary_main_categories AS c
                                  WHERE ($s) AND c.id = ".intval($row->parent_id);
                        $db->setQuery($sql_query);
                        $row = $db->loadObject();
                        if(isset($row) && $row->name!=''){
                          $cattitle[] = JFilterOutput::stringURLUnicodeSLug($row->name);
                          $cattitle_with_id[] = JFilterOutput::stringURLUnicodeSLug($row->name);
                        }
                      }
                      $segments_with_id = array_merge($segments,array_reverse($cattitle_with_id));
                      $segments = array_merge($segments,array_reverse($cattitle));
                    }
                }
                unset($query['catid']);
            }

            if(isset($query['id']) && ( $task == 'view' || $task == 'view_bl' || $task == 'view_author' ) ) {
                //if exist author or book, - this not end segment, so clean segments_with_id
                $segments_with_id = $segments;
            }


pu_log("booklibraryRouter:build 22:".$task."::",$query);             
            if(isset($query['id']) && ( $task == 'view' || $task == 'view_bl') ) {
                 $sql_query = "SELECT b.id, b.title FROM #__booklibrary AS b
                          \nLEFT JOIN #__booklibrary_categories AS bc ON bc.bookid=b.id
                          \nLEFT JOIN #__booklibrary_main_categories AS c ON c.id=bc.catid
                          \nWHERE ($s) AND b.id=".intval($query['id']);
                 $db->setQuery($sql_query);
                 $row = null;
                 $row = $db->loadObject();
                 if(isset($row)) {
                   $segments[] = JFilterOutput::stringURLUnicodeSLug($row->title);
                   $segments_with_id[] = JFilterOutput::stringURLUnicodeSLug($row->id. '_' .$row->title);
                 }
            } 

            if(isset($query['id']) && $task == 'view_author') {
             $sql_query = "SELECT a.id, a.authors_name"
                  . "\n FROM #__booklibrary_authors AS a"
                  . "\n WHERE a.id = " . intval( $query['id'] );
                    $db->setQuery($sql_query);
                    $row = null;
                    $row = $db->loadObject();
                     if(isset($row)) {
                    $segments[] = JFilterOutput::stringURLUnicodeSLug($row->authors_name);
                    $segments_with_id[] = JFilterOutput::stringURLUnicodeSLug($row->id. '_' .$row->authors_name);
              }
            }

            if(isset($query['id']) && $task == 'edit_book') {
                $segments[] = JFilterOutput::stringURLUnicodeSLug($query['id']);
                $segments_with_id[] = JFilterOutput::stringURLUnicodeSLug($query['id']);
            }

            if(isset($query['name']) && $task == 'view_user_books') {
                $segments[] = JFilterOutput::stringURLUnicodeSLug($query['name'] );
                unset($query['name']);
            }

            if(isset($query['efileid']) && $task == 'mdownload') {
                $segments[] = JFilterOutput::stringURLUnicodeSLug($query['efileid']);
                $segments_with_id[] = JFilterOutput::stringURLUnicodeSLug($query['efileid']);
                unset($query['efileid']);
            }            

            if ( isset($query['letindex']) ) {
                //if(count($segments) == 0 ) $segments[] = $task;
                $segments[] = JFilterOutput::stringURLUnicodeSLug('letindex_'.$query['letindex']);
                unset($query['letindex']);
            }            
            if (isset($query['limitstart'])) {
                //if(count($segments) == 0 ) $segments[] = $task;
                $segments[] = JFilterOutput::stringURLUnicodeSLug("ls_".$query['limitstart']);
                unset($query['limitstart']);
            }

            if (isset($query['limit'])) {
                //if(count($segments) == 0 ) $segments[] = $task;
                $segments[] = JFilterOutput::stringURLUnicodeSLug("l_".$query['limit']);
                unset($query['limit']);
            }

            unset($query['id']);
            unset($query['task']);
            unset($query['view']);
            unset($query['layout']);
            unset($query['is_show_data']);
            unset($query['tab']);


            $sefurl->ser_url_segments = serialize($segments);
            $sefurl->hash_url_segments = md5( $sefurl->ser_url_segments ) ;

            $sefurl_new = new mosSefurl($db);
            $sefurl_new = $sefurl_new->loadByHashUrlSegments($sefurl->hash_url_segments);
pu_log("booklibraryRouter:build 231:",$segments);
pu_log("booklibraryRouter:build 2301:",$sefurl->ser_url_segments);
pu_log("booklibraryRouter:build 2302:",$sefurl->hash_url_segments);
            if($sefurl_new != null 
                && count($segments_with_id) > 0 
                && $sefurl->hash_vars == $sefurl_new->hash_vars ) {
pu_log("booklibraryRouter:build 232:",$segments);                
                //$sefurl_new != null - this mean exist some duplecate with same url, 
                //$sefurl->hash_vars == $sefurl_new->hash_vars - mean all vars 
                // in url same(not only in segment)
                //so add to URL the ID
                $sefurl->ser_url_segments = serialize($segments_with_id);
                $sefurl->hash_url_segments = md5( $sefurl->ser_url_segments ) ;
                $segments = $segments_with_id;
            }else if($sefurl_new != null 
                && count($segments_with_id) == 0 
                && $sefurl->hash_vars == $sefurl_new->hash_vars ) {
pu_log("booklibraryRouter:build 233:",$segments);                
                //this mean exist some duplecate with same url, 
                //$sefurl->hash_vars == $sefurl_new->hash_vars - mean all vars 
                // in url same(not only in segment)
                //so add to URL the some hash code
                //need additional check for SEaRCH tasks, 
                //so task may check with date and hint, and remove all old 1 month
                //this condition must not happened, other some error  !!!!
                $hash = md5( serialize($query) ) ;
                $segments[] = $hash;
                $sefurl->ser_url_segments = serialize($segments);
                $sefurl->hash_url_segments = md5( $sefurl->ser_url_segments ) ;
            }else if($sefurl_new != null 
                && count($segments_with_id) > 0 
                && $sefurl->hash_vars != $sefurl_new->hash_vars ) {
pu_log("booklibraryRouter:build 234:",$segments);                
                //this mean exist some duplecate with same url, 
                //$sefurl->hash_vars != $sefurl_new->hash_vars - mean all vars 
                // in url NOT same(not only in segment)(as example exit item with same name)
                $sefurl->ser_url_segments = serialize($segments_with_id);
                $sefurl->hash_url_segments = md5( $sefurl->ser_url_segments ) ;
                $segments = $segments_with_id;
            }

            $sefurl->store();
pu_log("booklibraryRouter:build 3:",$segments);
            return $segments;

        }
pu_log("booklibraryRouter:build 4:");

//old code- if some errors:
    //     $menu = JFactory::getApplication()->getMenu();
    //     if (isset($query['Itemid'])) {

    //         if (!isset($menu->getItem($query['Itemid'])->component)) {
    //             $a = 'com_booklibrary';
    //             $b = 'view';        
    //         }
    //         else
    //             $a = $menu->getItem($query['Itemid'])->component;

    //         if (!isset($query['view']) && ($a == 'com_booklibrary') && !isset($query['task'])) {
    //             if (!isset($b))
    //                 $query['view'] = $menu->getItem($query['Itemid'])->query['view'];
    //             else
    //                 $query['view'] = $b;
    //         }

    //         if( isset($query['view']) && $query['view'] == "showCategory" && !isset($query['catid']) ) {
             
    //               $menu = new JTableMenu($db);
    //               $menu->load($query['Itemid']);
    //               $params = new JRegistry;
    //               $params->loadString($menu->params);
    //               $single_category = $params->get('single_category', '');
    //               if($single_category != "" ) $query['catid'] = $single_category;
    //         }
    //     }

    //     if (isset($query['option']) && $query['option'] == 'com_booklibrary') { //check component
    //         $segments[0] = (isset($query['Itemid'])) && ($query['Itemid'] != 0) ? $query['Itemid'] : '0';
    //         if ((isset($query['view'])) && (!isset($query['task']))) {
    //             $query['task'] = $query['view'];
    //         }

    //         if (isset($query['task'])) {

             

    //             switch ($query['task']) {
    //                 case 'new_url':
    //                     $segments[1] = 'buy_now';
    //                     break;
    //                 case 'new_url_for_vm':
    //                     $segments[1] = 'new_url_for_vm';
    //                     break;
    //                 case 'view_user_books':
    //                 case 'owner_books':
    //                     $segments[1] = $query['task'];
    //                     if (isset($query['name'])) {
    //                         $segments[] = JFilterOutput::stringURLUnicodeSLug($query['name']);
    //                         // $segments[] = $query['name'];
    //                         unset($query['name']);
    //                     }
    //                     break;
    //                 case 'lend_book' :
    //                     $segments[1] = $query['task'];
    //                     break;
                        
    //                case 'view_author' :
    //                     $segments[1] = $query['task'];
    //                     break;
                        
    //                // case 'all_authors' :
    //                //      $segments[1] = $query['task'];
    //                //      break;
                        
    //                 case 'categories' :
    //                     $segments[1] = "all_category";
    //                     break;
    //                 default:
    //                     $segments[1] = $query['task'];
    //                     break;
    //             }
    //         }
    //         $task = $query['task'];
    //         unset($query['task']);
    //         unset($query['view']);
        
    //         if (isset($query['catid']) && $task != "search") {
    //             if ($query['catid'] > 0) {
    //                 /* $sql_query = "SELECT blc.id, blc.name, bc.catid, blc.parent_id ".
    //                   " FROM #__booklibrary_main_categories AS blc".
    //                   " LEFT JOIN #__booklibrary_categories AS bc ON bc.catid=blc.id ".
    //                   " LEFT JOIN #__booklibrary AS b ON bc.bookid = b.bookid ".		//!!!!!!!!!!!!!!!!!!1
    //                   " WHERE blc.section = 'com_booklibrary' AND blc.id = ".intval($query['catid']);
    //                  */
    //                 /*$sql_query = "SELECT blc.name" .*/
    //                 $sql_query = "SELECT blc.alias" .
    //                         " FROM #__booklibrary_main_categories AS blc" .
    //                         " WHERE blc.id = " . intval($query['catid']);

    //                 $db->setQuery($sql_query);
    //                 $row = null;
    //                 $row = $db->loadObject();
    //                 if (isset($row)) {
    //                     $cattitle = array();
    //                     $segments[] = $query['catid'];
    //                     // $segments[] = JFilterOutput::stringURLUnicodeSLug($row->name);
    //                     $segments[] = JFilterOutput::stringURLUnicodeSLug($row->alias);
    //                     unset($query['catid']);
    //                 }
    //             } else {
    //                 $temp = $query['catid']; //is catid set??
    //                 unset($query['catid']);
    //             }
    //         }
        
    //         if (isset($query['letindex'])) {
    //           $segments[] = $query['letindex'];
    //           unset($query['letindex']);
              
    //           if (isset($query['sp'])) {
    //             $segments[] = $query['sp'];
    //               unset($query['sp']);
    //           }
        
    //           if (isset($query['sort'])) {
    //               $segments[] = $query['sort'];
    //               unset($query['sort']);
    //           }
              
    //         }
            

    //         if (!empty($query['lang'])) {
    //             unset($query['lang']);
    //         }
    // //          if (isset($query['Itemid'])) {
    // //              unset($query['Itemid']);
    // //          }
    // //          if (!empty($query['Itemid'])) {
    // //              $query['Itemid'] = "";
    // //              unset($query['Itemid']);
    // //          }

    //         if (isset($query['name'])) {
    //             $segments[] = JFilterOutput::stringURLUnicodeSLug($query['name']);
    //             unset($query['name']);
    //         }

    //         if (isset($query['user'])) {
    //             $segments[] = $query['user'];
    //             unset($query['user']);
    //         }
        
    //         if (isset($query['id']) && $task != "view_author") {
    //             $sql_query = "SELECT bc.catid AS catid, b.title"
    //                     . "\n FROM #__booklibrary AS b"
    //                     . "\n LEFT JOIN #__booklibrary_categories AS bc ON bc.bookid=b.id"
    //                     . "\n LEFT JOIN #__booklibrary_main_categories AS blc ON blc.id=bc.catid"
    //                     . "\n WHERE b.id = " . intval($query['id']);

    //             $db->setQuery($sql_query);
    //             $row = null;
    //             $row = $db->loadObject();
    //             if (isset($row)) {
    //                 $temp_title = JFilterOutput::stringURLUnicodeSLug($row->title);
    //                 if (isset($temp)) {
    //                     $segments[] = $row->catid;
    //                 }
    //                 $segments[] = $query['id']; //for back up in parseroute
    //                 $segments[] = $temp_title;
    //                 unset($query['id']);
    //             }
    //         }
        
    //         if (isset($query['id']) && $task == "view_author") {
    //             $sql_query = "SELECT a.authors_name"
    //                     . "\n FROM #__booklibrary_authors AS a"
    //                     . "\n WHERE a.id = " . intval($query['id']);
    //             $db->setQuery($sql_query);
    //             $row = null;
    //             $row = $db->loadObject();

    //             if (isset($row)) {
    //                 $temp_title = JFilterOutput::stringURLUnicodeSLug($row->authors_name);
    //                 $segments[] = $query['id']; //for back up in parseroute
    //                 $segments[] = $temp_title;
    //                 unset($query['id']);
    //             }
    //         }
        
    //         if (isset($query['viewtype'])) {
    //             $segments[] = 'viewtype' . ":" . $query['viewtype'];
    //             unset($query['viewtype']);
    //         }

    //         if (isset($query['searchtext'])) {
    //             $segments[] = $query['searchtext'];
    //             unset($query['searchtext']);
    //         }

    //         if (isset($query['limitstart'])) {
    //             $segments[] = $query['limitstart'];
    //             unset($query['limitstart']);
    //         }

    //         if (isset($query['limit'])) {
    //             $segments[] = $query['limit'];
    //             unset($query['limit']);
    //         }

    //                 // if (isset($query['searchtype'])) {
    //         //     $segments[] = $query['searchtype'];
    //         //     unset($query['searchtype']);
    //         // }
    //     }
        
    //     // print_r("booklibraryRouter:build end:");
    //     // print_r($segments);   
    //     // exit;

    //     // echo "<br>";
    //     return $segments;
    }

    /**
     * Parse the segments of a URL.
     * */
    public function parse(&$segments)
    {
         pu_log("booklibraryRouter:parse 1:",$segments);
        // exit;

        $vars = array();
        $db = JFactory::getDBO();

        $sefurl = new mosSefurl($db);
        $ser_segments = serialize($segments) ;
        $hash_segments = md5( $ser_segments );
pu_log("booklibraryRouter:parse 2301:",$ser_segments);
pu_log("booklibraryRouter:parse 2302:",$hash_segments);

        $sefurl = $sefurl->loadByHashUrlSegments($hash_segments);
        if($sefurl != null ) {
pu_log("booklibraryRouter:parse 1ю1:");            
            foreach ($segments as $key => $value) {
                unset($segments[$key]);
            }

            $vars = unserialize( $sefurl->ser_vars ) ;
pu_log("booklibraryRouter:parse 2:",$vars);            
            return $vars;
        }
         pu_log("booklibraryRouter:parse 3:");


//old code - if some error :

       //  $count = count($segments);
       //  $vars['option'] = 'com_booklibrary';

       //  $menu = JFactory::getApplication()->getMenu();
       //  $menu->setActive($segments[0]);
       //  /* if($segments[0] != 'rent_requests_cb_books')
       //    $vars['Itemid'] = $segments[0]; */
       //  switch ($segments[0]) {
       //      case 'rent_history_books':
       //          break;
       //      case 'rent_requests_cb_books':
       //          break;
       //      case 'show_my_books':
       //          break;
       //      default:
       //          $vars['Itemid'] = $segments[0];
       //          break;
       //  }


          
       //  if (( @$segments[1] == "alone_category" || @$segments[1] == "showCategory") 
       //        && isset($segments[3]) && (is_int($segments[3]) || $segments[3] == '0')) {
       //      $vars['task'] = "showCategory";
       //      $vars['limitstart'] = $segments[2]; 
       //      $vars['limit'] = $segments[3];
        
       //  } elseif ((  @$segments[1] == "alone_category" || @$segments[1] == "showCategory") && isset($segments[2])) {
       //      $vars['task'] = "showCategory";
       //      $vars['catid'] = @$segments[2];
      
       //      if( (isset($segments[4]) && strlen($segments[4]) == '1' ) 
       //       && (isset($segments[5]) && is_numeric($segments[5]) && strlen($segments[5]) == '1' ) 
       //       && (isset($segments[6]) && !is_numeric($segments[6])  ) 
       //       ) {
       //        unset($segments[3]); //name category, for not set below to limitstart
       //        $vars['letindex'] = $segments[4];
       //        $vars['sp'] = $segments[5];
       //        if (isset($segments[6])) {
       //           $vars['sort'] =  $segments[6];
       //        }      
       //        if (isset($segments[7])) {
       //           $vars['limitstart'] = (int) $segments[7];
       //        }      
       //      }elseif( (isset($segments[4]) && is_numeric($segments[4]) ) ) {
       //        unset($segments[3]); //name category, for not set below to limitstart
       //        $vars['limitstart'] = $segments[4];
       //        if (isset($segments[5])  && is_numeric($segments[5]) ) {
       //           $vars['limit'] =  $segments[5];
       //        }      
       //      }

            
       //      if (isset($segments[4]) && isset($segments[3]) && strpos($segments[3],':') != false ) {
       //          $viewtype = explode(':', $segments[3]);
       //          if ($viewtype[0] == "viewtype") {
       //              $vars['viewtype'] = (int) $viewtype[1];
       //          }
       //      }

            
       //      if (isset($segments[3]) && !isset($vars['viewtype']) && !isset($vars['limitstart']) ) {
       //          $vars['limitstart'] = $segments[3];
       //      }
       //      if (isset($segments[4]) && !isset($vars['viewtype'])  && !isset($vars['limit'])  
       //            && !isset($vars['letindex']) && is_numeric($segments[4]) ) {
       //          $vars['limit'] = $segments[4];
       //      }

            
       //      if (isset($segments[5])) {
       //          $viewtype = explode(':', $segments[5]);
       //          if ($viewtype[0] == "viewtype") {
       //              $vars['viewtype'] = (int) $viewtype[1];
       //          }
       //      }
            
       //  }  elseif (@$segments[1] == "lend_book") {
       //      $vars['task'] = "lend_book";
       //  }  elseif (@$segments[1] == "show_my_books" || @$segments[1] == "showmybooks") {
       //      $vars['task'] = $segments[1];
       //      if(isset($segments[2]) && $segments[2] > 0 
       //        && !isset($vars['limitstart']) ) $vars['limitstart'] = $segments[2];
       //  } elseif(isset($segments[1]) && $segments[1] == "books") {
       //    $vars['task'] = "books";

       //    if(!is_numeric(@$segments[2]) && (@$segments[3]) == '1'){

       //      $vars['letindex'] = $segments[2];
       //      $vars['sp'] = $segments[3];
       //      if (isset($segments[4]) && $segments[4] > 0 ) {
       //        $vars['limitstart'] = $segments[4]; 
       //      }
       //      if (isset($segments[5]) && $segments[5] > 0 ) {
       //        $vars['limit'] = $segments[5];
       //      }
       //    } else if (isset($segments[2]) && $segments[2] > 0 && isset($segments[3]) 
       //        && is_numeric($segments[3])) {
       //      $vars['limitstart'] = $segments[2]; 
       //      $vars['limit'] = $segments[3];
       //    } else if (isset($segments[2]) && $segments[2] > 0 ) {
       //      $vars['limitstart'] = $segments[2]; 
       //    }
       //    unset($vars['limit']);
       //  }
       //  elseif (@$segments[1] == "all_authors") {
       //      $vars['task'] = "all_authors";

       //    if(!is_numeric(@$segments[2]) && (@$segments[3]) == 'one'){
       //      $vars['letindex'] = $segments[2];
       //      $vars['sp'] = $segments[3];
       //      if (isset($segments[4]) && $segments[4] > 0 ) {
       //        $vars['limitstart'] = $segments[4]; 
       //      }
       //      if (isset($segments[5]) && $segments[5] > 0 ) {
       //        $vars['limit'] = $segments[5];
       //      }
       //    } elseif(isset($segments[2]) && intval($segments[2]) > 0 && isset($segments[3]) && intval($segments[3])> 0)
       //      {
       //        $vars['limitstart'] = $segments[2]; 
       //        $vars['limit'] = $segments[3];
       //      } else if (isset($segments[2]) && intval($segments[2]) > 0 ) {
       //        $vars['limitstart'] = $segments[2]; 
       //      }
       //      unset($vars['limit']);
       //  }
       //  elseif ( (@$segments[1] == "view" || @$segments[1] == "view_bl" ) && isset($segments[4])) {
       //      $vars['task'] = @$segments[1];
       //      $id_tmp = (int) $segments[3];
       //      if ( $id_tmp > 0 ){
       //          $vars['id'] = (int) $segments[3];
       //      }
       //      else/* if (is_integer($segments[4])) */
       //          $vars['id'] = (int) $segments[4];
       //      $vars['catid'] = $segments[2];
            
       //  }
       //  elseif ( (@$segments[1] == "view" || @$segments[1] == "view_bl" ) && !isset($segments[4])) {
       //      $vars['task'] = @$segments[1];

       //      $id_tmp = (int) $segments[3];
       
       //      if ( $id_tmp > 0 ){
       //          $vars['id'] = (int) $segments[3];
       //      }
       //      else $vars['id'] = (int) $segments[4];
       //      $vars['catid'] = $segments[2];
            
       //  } elseif (@$segments[0] == "show_my_books") {
       //      $vars['task'] = 'show_my_books';
       //  } elseif (@$segments[0] == "rent_history_books") {
       //      $vars['task'] = 'rent_history_books';
       //      $vars['name'] = $segments[1];
       //      $vars['number'] = $segments[2];
       //  } elseif (@$segments[0] == "rent_requests_cb_books") {
       //      $vars['task'] = 'rent_requests_cb_books';
       //  } elseif (@$segments[1] == "edit_book") {
       //      $vars['task'] = $segments[1];
       //      $vars['id'] = $segments[2];
       //      if (isset($segments[3]))
       //          $vars['limit'] = $segments[3];
       //  }elseif (@$segments[1] == "owners_list") {
       //      $vars['task'] = $segments[1];
       //  } elseif (@$segments[1] == "view_user_books") {
       //      $vars['task'] = $segments[1];
       //      //$vars['name'] = "Super User";//$segments[2];
       //      if (isset($segments[2])) {
       //          if (/* eregi */preg_match("|:|", $segments[2])) {
       //              $viewtype = explode(':', $segments[2]);
       //              $vars['name'] = null;
       //              for ($a = 0; $a < count($viewtype); $a++) {
       //                  $vars['name'] .= $viewtype[$a];
       //                  if ($a < count($viewtype) - 1)
       //                      $vars['name'] .= " ";
       //              }
       //          }
       //          else {
       //              $vars['name'] = $segments[2];
       //          }
       //      }

       //      if (isset($segments[3]) && !isset($vars['viewtype'])) {
       //          $vars['limitstart'] = $segments[3];
       //      } else {
       //          unset($vars['limitstart']);
       //      }
       //      if (isset($segments[4]) && !isset($vars['viewtype'])) {
       //          $vars['limit'] = $segments[4];
       //      } else {
       //          unset($vars['limit']);
       //      }

       //  } elseif (@$segments[1] == "lend_return_book") {

       //      $vars['task'] = "lend_return_book";
       //  } elseif (@$segments[1] == "search") {
       //      $vars['task'] = "search";

       //      if (isset($segments[2])) {
       //          $vars['searchtext'] = $segments[2];
       //      }
       //      // if (isset($segments[5])) {
       //      //     $vars['searchtype'] = $segments[5];
       //      // }
       //      if (isset($segments[3])) {
       //          $vars['limitstart'] = $segments[3];
       //      } else {
       //          unset($vars['limistart']);
       //      }
       //      if (isset($segments[4])) {
       //          $vars['limit'] = $segments[4];
       //      } else {
       //          unset($vars['limit']);
       //      }
       //  // add in version 3.6.6
       //  } elseif (@$segments[1] == "search_book") { 

       //    $vars['task'] = "search_book";

       //    if (isset($segments[2])) {
       //        $vars['searchtext'] = $segments[2];
       //    }

       //    if (isset($segments[3])) {
       //        $vars['limitstart'] = $segments[3];
       //    } else {
       //        unset($vars['limistart']);
       //    }
       //    if (isset($segments[4])) {
       //        $vars['limit'] = $segments[4];
       //    } else {
       //        unset($vars['limit']);
       //    }      // echo 33333333333;
       //    // print_r($vars);
       //  // *************************    
       //  } elseif (@$segments[1] == "wishlist") { 
       //    $vars['task'] = "wishlist";
       //    // if (isset($segments[4])) {
       //    //     $vars['searchtype'] = $segments[4];
       //    // }
       //    if (isset($segments[2])) {
       //        $vars['limitstart'] = $segments[2];
       //    } else {
       //        unset($vars['limistart']);
       //    }
       //    if (isset($segments[3])) {
       //        $vars['limit'] = $segments[3];
       //    } else {
       //        unset($vars['limit']);
       //    }

       //  // *************************                                         
       //  } elseif (@$segments[1] == "show_search") {  
       //      $vars['task'] = "show_search";
       //      if (isset($segments[4])) {
       //          $vars['searchtext'] = $segments[4];
       //      }
       //      // if (isset($segments[5])) {
       //      //     $vars['searchtype'] = $segments[5];
       //      // }

       //      if (isset($segments[2])) {
       //          $vars['limitstart'] = $segments[2];
       //      } else {
       //          unset($vars['limistart']);
       //      }
       //      if (isset($segments[3])) {
       //          $vars['limit'] = $segments[3];
       //      } else {
       //          unset($vars['limit']);
       //      }
       //  } elseif (@$segments[1] == "show_rss_categories") {
       //      $vars['task'] = "show_rss_categories";
       //  } elseif (@$segments[1] == "buy_now") {
       //      $vars['task'] = "new_url";
       //      if (isset($segments[2])) {
       //          $vars['id'] = $segments[2];
       //      }
       //  } elseif (@$segments[1] == "new_url_for_vm") {
       //      $vars['task'] = "new_url_for_vm";
       //      if (isset($segments[2])) {
       //          $vars['id'] = $segments[2];
       //      }
       //  } elseif (@$segments[1] == "view_user_books") {
       //      $vars['task'] = "view_user_books";
       //      if (isset($segments[2])) {
       //          $vars['name'] = $segments[2];
       //      }
       //  } elseif (@$segments[1] == "view_author") {
       //      $vars['task'] = "view_author";
       //      if (isset($segments[3])) {
       //          $vars['authors_name'] = $segments[3];
       //      }
       //  if (isset($segments[2])) {
       //          $vars['id'] = $segments[2];
       //      }
       //  }
        
       //  elseif (@$segments[1] == "owner_books") {
       //      $vars['task'] = "owner_books";
       //      if (isset($segments[2])) {
       //          $vars['name'] = $segments[2];
       //      }
       //  } 

       //  elseif (@$segments[1] == "lend_history") {
       //      $vars['task'] = "lend_history";
       //      $vars['name'] = $segments[2];
       //      $vars['user'] = $segments[3];
       //  } elseif (@$segments[1] == "lend_requests") {
       //      $vars['task'] = "lend_requests";
       //      if (isset($segments[2])) {
       //          $vars['limitstart'] = $segments[2];
       //      } else {
       //          unset($vars['limistart']);
       //      }
       //      if (isset($segments[3])) {
       //          $vars['limit'] = $segments[3];
       //      } else {
       //          unset($vars['limit']);
       //      }

       //  } elseif (@$segments[1] == "mdownload") {
       //      $vars['task'] = "mdownload";
       //      if (isset($segments[2])) {
       //          $vars['id'] = $segments[2];
       //      }
       //  } else {
       //      $vars['task'] = @$segments[1];
       //  }


       //  foreach ($segments as $key => $value) {
       //      unset($segments[$key]);
       //  }

       // // echo "<hr>";
       //  // print_r("booklibraryRouter:parse end:");
       //  // print_r($vars);
       //  // exit;

       //  return $vars;

    }

}


function booklibraryBuildRoute(&$query)
{
    $app = JFactory::getApplication();
    $router = new booklibraryRouter($app, $app->getMenu('site'));

    return $router->build($query);
}

function booklibraryParseRoute($segments)
{
    $app = JFactory::getApplication();
    $router = new booklibraryRouter($app, $app->getMenu('site'));

    return $router->parse($segments);
}
