<?php
/**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . 
    basename(__FILE__) . ' is not allowed.');

if ($cat_name != "") $category_url_part = "task=$cat_name";
else $category_url_part = "task=books&amp;catid=$catid"; //showCategory
$session = JFactory::getSession();
$arr = $session->get("array", "default");
global $doc, $hide_js, $Itemid, $mosConfig_live_site, $mosConfig_absolute_path;
global $limit, $total, $limitstart, $Itemid, $task, $paginations, $mainframe, 
       $booklibrary_configuration;
       

$doc->addStyleSheet($mosConfig_live_site . '/components/com_booklibrary/includes/custom.css');

if( checkJavaScriptIncluded("jQuerBook-1.2.6.js") === false )   {
  $doc->addScript(JURI::root(true) . '/components/com_booklibrary/lightbox/js/jQuerBook-1.2.6.js');
}   
if( checkJavaScriptIncluded("jquery.raty.js") === false )   {
  $doc->addScript(JURI::root(true) . '/components/com_booklibrary/includes/jquery.raty.js');
}   
?>

<noscript>
    Javascript is required to use Book Library 
    <a href="https://ordasoft.com/book-library"
>book library software</a>,
    <a href="https://ordasoft.com/book-library"
>Joomla Book library</a>
</noscript>
<style type="text/css">
  .okno{width: <?php echo $booklibrary_configuration['foto']['width'] + 10; ?>px;}
  .okno img{width:<?php echo $booklibrary_configuration['foto']['width']; ?>px;
            max-height: <?php echo $booklibrary_configuration['foto']['high']; ?>px;}
  .okno .titlemedia{min-height:60px;}
</style> 
<script type="text/javascript">
    function lend_request_submitbutton() {
        var form = document.userForm;
        if (form.user_name.value == "") {
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_NAME; ?>" );
        } else if (form.user_email.value == "" || !isValidEmail(form.user_email.value)) {
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_EMAIL; ?>" );
        } else if (form.user_mailing == "") {       
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_MAILING; ?>" );
        } else if ((form.lend_until.value == "") || (form.lend_until.value < form.lend_from.value)) {  
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_UNTIL; ?>" );
        } else {
            form.submit();
        }
    }
    function isValidEmail(str) {
        return (str.indexOf("@") > 1);
    }
    
    function allreordering(){
        if(document.orderForm.direction.value=='asc')
            document.orderForm.direction.value='desc';
        else document.orderForm.direction.value='asc';

        document.orderForm.submit();
    }
</script>

<div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">

    <?php if ($params->get('show_page_heading') && $params->get('header') != "" ) {  ?>
                <h1><?php echo $params->get('header'); ?></h1>
    <?php } else {  ?>
                <h1><?php echo _BOOKLIBRARY_LABEL_ALLBOOKS;  ?></h1>                
    <?php } ?>


<table class="abc" border="0" cellpadding="4" cellspacing="0" width="100%">
    <tr>                
        <?php
            if ($currentcat->img != null && $currentcat->align == 'left' 
                && $params->get('show_cat_pic')) {
        ?>
            <td>
                <img src="<?php echo $currentcat->img; ?>" 
                     align="<?php echo $currentcat->align; ?>" alt="?"/>
            </td>
            <?php
            }
                if (!$params->get('wrongitemid')) {
            ?>
            <td width = "65%">
            <?php echo $currentcat->descrip; ?>
            </td>
            <?php
                if ($currentcat->img != null && $currentcat->align == 'right') {
            ?>
                <td>
                    <img src="<?php echo $currentcat->img; ?>" 
                         align="<?php echo $currentcat->align; ?>" alt="?" />
                </td>
                <?php
                    }
                }
                ?>
                
    </tr>
</table>
<?php
if (strpos($currentcat->header, _BOOKLIBRARY_LABEL_SEARCH) && count($rows) == 0) {
?>
    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
        <?php echo _BOOKLIBRARY_NOTHING_FOUND; ?>
    </div>
<?php
    mosHTML::BackButton($params, $hide_js);
    return;
}

//print_r($params);

?>
    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
        <div class="basictable this27">
                    <?php
                        if ($params->get('advsearch_show')) 
                        echo '<div class="bl_bl_single_category_top_advanced_search 
                            my_btn my_btn-info"><a href="' . JRoute::_('index.php?option=com_booklibrary&task=show_search&catid=0&Itemid=' . $Itemid ). '">' . 
                            _BOOKLIBRARY_ADMIN_CONFIG_ADVSEARCH . '</a></div>';
                       if ($params->get('search_fieldshow')) echo HTML_booklibrary::displaySimpleSearch();
                    ?>
        </div>
    </div>
    <?php

    $total = count($rows);
    if ($total > 0) {
        $sort_arr['field'] = $params->get('sort_arr_field');
        $sort_arr['direction'] = $params->get('sort_arr_direction');
     //   $def_sort = $params->get('def_sort');
     //   print_r($sort_arr);
    ?>
    <table width="100%" class="basictable this28">
        <tr>
        <?php if ($params->get('header') != 'Lend Request') { ?> 
                <td >
                    <div id="ShowOrderBy" style="text-align:right" >
                        <form class="o" id="adminForm" method="POST" 
                              action="<?php echo $_SERVER["REQUEST_URI"]; ?>" name="orderForm">
                            <input type="hidden" id="direction" name="direction" 
                                   value="<?php echo $sort_arr['direction']; ?>" >
                            <a title="Click to sort by this column." 
                               onclick="javascript:allreordering();return false;" href="#">
                                <img alt="" src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/sort_<?php
        if ($sort_arr['direction'] == false) {
            echo 'asc';
        } else {
            echo $sort_arr['direction'];
        } ?>.png" />
            </a>
        <?php echo _BOOKLIBRARY_LABEL_ORDER_BY; ?> <select size="1" class="inputbox" 
            onchange="javascript:document.orderForm.direction.value='asc'; document.orderForm.submit();" 
            id="field" name="field">
        <option value="authors" <?php if ($sort_arr['field'] == "authors") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_AUTHORS; ?></option>
        <option value="title" <?php if ($sort_arr['field'] == "title") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_TITLE; ?></option>
        <option value="rating" <?php if ($sort_arr['field'] == "rating") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_RATING; ?></option>
        <option value="hits" <?php if ($sort_arr['field'] == "hits") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_HITS; ?></option>
          </select>       
              </form>
                    </div>
                </td>
    
        <?php } ?>

        </tr>
    </table>                
        <?php
            $available = false;
        ?>
    <div id="gallery">
        <?php
        $total = count($rows);
        foreach($rows as $row) {
            $cat_id = @(isset($row->category_id)) ? $row->category_id : $catid;
            $link = 'index.php?option=com_booklibrary&amp;task=view&amp;id=' . $row->id . 
                '&amp;catid=' . $cat_id . '&amp;Itemid=' . $Itemid;
            $imageURL = $row->imageURL;
        ?>
                <div class="okno" style="position:relative">
                    <div>
                        <a href="<?php echo sefRelToAbs($link); ?>" >
        <?php
            if ($imageURL != '') {
                if ($imageURL != '' && substr($imageURL, 0, 4) != "http") {
                    $imageURL = $mosConfig_live_site . '' . $imageURL;;
                }
                echo '<img height="' . $booklibrary_configuration['foto']['high'] . '"
                                          width="' . $booklibrary_configuration['foto']['width'] . 
                                          ' "src="' . $imageURL . '" border="0">';
            } else {
                echo '<img  height="' . $booklibrary_configuration['foto']['high'] . '"
                                          width="' . $booklibrary_configuration['foto']['width'] . 
                                          '" src="' . './components/com_booklibrary/images/' . 
                                          _BOOKLIBRARY_NO_PICTURE . 
                                          '" alt="no-img_eng_big.png" border="0"  />';
            }
        ?>
                        </a>
                    </div>
                    <div class="textmedia">
                        <div class="titlemedia">
                            <a href="<?php echo sefRelToAbs($link); ?>" >
                            <?php
                                if (mb_strlen($row->title) > 30) echo mb_substr($row->title, 0, 30), '...';
                                else {
                                    echo $row->title;
                                }
                            ?>
                            </a>
                        </div>
                        <div class="authors">
                        <?php
                            if (mb_strlen($row->authors) > 15) echo mb_substr($row->authors, 0, 15), '...';
                            else {
                                echo $row->authors;
                            }
                        ?>
                        </div>
                    </div>

                </div>
            <?php } ?>
                </div>
                <br />
                <?php //show index for field authors,title
                if ($sort_arr['field'] == "authors" || $sort_arr['field'] == "title") {
            ?>
                    <div id="paginator-custom-index">    
            <?php
            foreach($list_str as $a) {
                echo $a;
            }
            ?>
            </div>    
    <?php
        } // close show index
    ?>
    <?php } ?>
            <div id="paginator-custom">
                <?php
                if ($pageNav != null && $pageNav->total > $pageNav->limit) {
                    echo $pageNav->getPagesLinks(); 
                }
                ?>
            </div>
    <?php
    if ($params->get('show_lendstatus') && $params->get('show_lendrequest') 
        && $params->get('lend_save')) {
    ?>

    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
                    <?php echo _BOOKLIBRARY_LABEL_LEND_INFORMATIONS; ?>
        <input type="hidden"  name="bookid" id="bookid"  value="<?php echo $row->id ?>"  maxlength="80" />

    </div>
    <form class="p" id="adminForm" action="<?php echo sefRelToAbs("index.php"); ?>" 
          name="userForm" method="post">
        <table  class="basictable this30" width="100%" border="0" cellspacing="0" cellpadding="0">            
            <tr>
                <td colspan="2">&nbsp;</td>
            </tr>

            <tr>
                <td>
                    <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_NAME;
                    global $my;?>:<br />
                    <input class="inputbox" type="text" name="user_name" size="38" maxlength="80" 
                    value="<?php if ($my->name != '') echo $my->name ?>" />       
                </td>
                <td>
                    <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_EMAIL; ?>:<br />
                    <input class="inputbox" type="text" name="user_email" size="38" maxlength="80" 
                    value="<?php if ($my->name != '') echo $my->email ?>"/>
                </td>
            </tr>
            <tr>
                <td colspan="2">&nbsp;</td>
            </tr>
        </table>                                      

        <script>
            Date.prototype.toLocaleFormat = function(format) {
                var f = {Y : this.getYear() + 1900,m : this.getMonth() +
                  1,d : this.getDate(),H : this.getHours(),M : this.getMinutes(),S : this.getSeconds()}
                for(k in f)
                    format = format.replace('%' + k, f[k] < 10 ? "0" + f[k] : f[k]);
                return format;
            };

                        
            window.onload = function ()
            {
                var today = new Date();
                var date = today.toLocaleFormat("<?php echo $booklibrary_configuration['date_format'] ?>");
                document.getElementById('lend_from').value = date;
                document.getElementById('lend_until').value = date;
            }; 

        </script>

        <table  class="basictable this31" width="100%" border="0" cellspacing="0" cellpadding="0">              
            <tr>
                <td>
                        <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_MAILING; ?>:<br />         

                    <!--editorArea( 'editor1',  '' , 'user_mailing', '400', '200', '30', '5' ) ;-->       

                    <textarea align= "top" name="user_mailing" id="user_mailing" cols="60" rows="10" 
                              style="width:400;height:100;" 
                              value="<?php 
                              // if ( isset($_REQUEST["comment"]) ) {echo $_REQUEST["comment"];}?>"/>
                    </textarea>                
                </td>
                <td>
                    <br />
                    <p>
                        <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_FROM; ?>:<br />

                        <?php 
                        echo JHtml::_('calendar', date("Y-m-d"), 'lend_from', 'lend_from', 
                            $booklibrary_configuration['date_format']); ?>
                    </p>
                    <p>
                        <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_UNTIL; ?>:<br />

                        <?php 
                        echo JHtml::_('calendar', date("Y-m-d"), 'lend_until', 'lend_until', 
                            $booklibrary_configuration['date_format']); ?>
                    </p>
                </td>
            </tr>
        </table>

        <?php } ?>

    <table  class="basictable this32" width="100%" border="0" cellspacing="0" cellpadding="0">
        <tr>
            <td width="260">
                <?php
                    if ($params->get('show_lendstatus') && $params->get('show_lendrequest') && 
                        $params->get('lend_save')) {
                ?>
              <input type="hidden" name="option" value="com_booklibrary"/>
              <input type="hidden" name="task" value="save_lend_request"/>
              <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>"/>
              <input type="button" class="button" 
                     value="<?php echo _BOOKLIBRARY_LABEL_BUTTON_LEND_REQU_SAVE; ?>" 
                     onclick="lend_request_submitbutton()" />
              <input type="hidden" name="bookid" value="<?php echo $rows[0]->id; ?>"/>
              <input type="hidden" name="bid[]" value="<?php echo $rows[0]->id; ?>"/>
           </form> 
                <?php
                } else {
                ?>
                    &nbsp;

                <?php } ?>

            </td>                         
            <td align="right">
                <?php
                    //     displays back button
                    if (count($rows)) mosHTML::BackButton($params, $hide_js);
                ?>
            </td>
        </tr>
    </table>

    <?php // } ?>             




</div> <!-- end class componentheading -->
<div style="text-align: center;font-size: 10px;"><a href="https://ordasoft.com/book-library" >Joomla Book Library</a>, by OrdaSoft!</div>
