<?php
/**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . 
    basename(__FILE__) . ' is not allowed.');

global $doc; 
global $hide_js, $Itemid, $acl, $mosConfig_live_site, $my, $mainframe;
$doc->addStyleSheet($mosConfig_live_site . 
    '/components/com_booklibrary/includes/custom.css'); 
?>

<noscript>
    Javascript is required to use Book Library 
    <a href="https://ordasoft.com/book-library"
>BookLibrary - ebook software for create book library website</a>,
    <a href="https://ordasoft.com/book-library"
>Book library plugin</a>
</noscript>

<div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">

    <?php if ($params->get('show_page_heading') && $params->get('header') != "" ) {  ?>
                <h1><?php echo $params->get('header'); ?></h1>
    <?php } else {  ?>
                <h1><?php echo _BOOKLIBRARY_ALL_CATEGORIES;  ?></h1>                
    <?php } ?>

<div  class="all_categories_logo">
<?php 
    if(isset($currentcat->descrip) ){
?>
            <span class="my_alert">
                <?php echo $currentcat->descrip; ?>
            </span>    
<?php 
    }//if(isset($currentcat->descrip) )
?>
            <span>
                <img src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/book.png" align="right" alt="Books"/>
            </span>
</div>

    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
        <div  class="all_categories_search">
        <?php
    
        if ($params->get('advsearch_show')) if ($params->get('advsearch_show')) 
                echo '<div class="bl_bl_single_category_top_advanced_search 
                      my_btn my_btn-info"><a href="' . $mosConfig_live_site . 
                      '/index.php?option=com_booklibrary&task=show_search&catid=0&Itemid=' . $Itemid . '">' . 
                      _BOOKLIBRARY_ADMIN_CONFIG_ADVSEARCH . '</a></div>';
        if ($params->get('search_fieldshow')) echo HTML_booklibrary::displaySimpleSearch();
        ?>
        <?php
            $link = 'index.php?option=com_booklibrary&task=show_search&catid=' . $catid . 
                '&Itemid=' . $Itemid;;
        ?>
                     <!--a href="<?php echo sefRelToAbs($link); ?>" >
                     <img src="./components/com_booklibrary/images/search.gif" 
                        alt="Search" border="0" />
                        <?php echo _BOOKLIBRARY_LABEL_SEARCH; ?>
                     </a-->
        </div>
    </div>
    

    <form class="bl_table_list_all_categories" id="adminForm" action="index.php" method="post" 
          name="adminForm">
    <?php
        //HTML_booklibrary::listCategories($params, $categories, $catid, $tabclass, $currentcat);
     ?>
        <div class="bl_bl_single_category_list_categories_table my_table-bordered show_categories_wrapper">
            <div class="show_categories_wrapper_title">
                <div class="sectiontableheader sectiontableheader_category<?php echo $params->get('pageclass_sfx'); ?>">
        <?php echo _BOOKLIBRARY_LABEL_CATEGORY; ?>
                </div>
                <div class="sectiontableheader sectiontableheader_books<?php echo $params->get('pageclass_sfx'); ?>">
                <?php echo _BOOKLIBRARY_LABEL_BOOKS; ?> 
                </div>


                <div class="sectiontableheader sectiontableheader_rss" style="text-align:center;">
                <?php
                    $Itemid = intval(mosGetParam($_REQUEST, 'Itemid', 0));
                ?>
                        <?php  
              if ($params->get('rss_show')){ ?>
                        <a href="<?php echo $mosConfig_live_site; ?>/index.php?option=com_booklibrary&task=show_rss_categories&Itemid=<?php 
                            echo $Itemid; ?>">
                            <img src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/rss.gif" 
                                 alt="All categories RSS" title="All categories RSS"/>
                        </a>
                        <?php } ?>
                </div>

                
            </div>
                
            <div class="show_categories_list_wrapper">
                    <?php
                        HTML_booklibrary::showInsertSubCategory($catid, $categories, $params, $tabclass, 
                                                                $Itemid, 0,$layout="_one_item1");
                    ?>
            </div>
        </div>



    <table  class="basictable bl_bl_all_categories_some_intresting_table_with_button" 
            width="100%" border="0" cellspacing="0" cellpadding="0">
        <tr>
            <td width="50%">&nbsp;
            </td>
            <td width="50%">
                <?php mosHTML::BackButton($params, $hide_js); ?>
            </td>
        </tr>
    </table>
</form>

</div> <!-- end class componentheading -->
<div style="text-align: center;font-size: 10px;"><a href="https://ordasoft.com/book-library" >Book Library plugin</a>, by OrdaSoft!</div>
