<?php
/**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
 if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . 
  basename(__FILE__) . ' is not allowed.');
global $doc, $hide_js, $Itemid, $mainframe,$database, $mosConfig_live_site;

if( checkJavaScriptIncluded("jQuerBook-1.2.6.js") === false )   {
  $doc->addScript(JURI::root(true) . '/components/com_booklibrary/lightbox/js/jQuerBook-1.2.6.js');
} 
if( checkJavaScriptIncluded("jquery-ui.js") === false )   {
  $doc->addScript(JURI::root(true) . '/components/com_booklibrary/includes/jquery-ui.js');
} 
 ?>

 <noscript>
     Javascript is required to use Book Library 
     <a href="https://ordasoft.com/book-library"
>Book Library - for create online library for ebook</a>,
     <a href="https://ordasoft.com/book-library"
>Joomla Book library</a>
 </noscript>

<?php 
$doc->addStyleSheet($mosConfig_live_site . 
  '/components/com_booklibrary/includes/jquery-ui.css'); 


$script_content = '';
$script_content .= "	function trim(string){	return string.replace(/(^\s+)|(\s+$)/g, '');	} \n";
$script_content .= "	function searchsubmit() \n";
$script_content .= "	{ \n";
$script_content .= "		var form = document.com_booklibsearchForm; \n";
$script_content .= "		var flag = true; \n";
$script_content .= "// 				var t_lprice = trim(document.getElementById('lprice').value); \n";
$script_content .= "// 				var t_uprice = trim(document.getElementById('uprice').value); \n";
$script_content .= "// 				var t_ldate = trim(document.getElementById('ldate').value); \n";
$script_content .= "// 				var t_udate = trim(document.getElementById('udate').value); \n";
$script_content .= "// 				if(!((t_lprice!='' && t_uprice!='') || (t_uprice == t_lprice))) \n";
$script_content .= "// 				{ \n";
$script_content .= "// 					alert('If you want search by price - interval must be set') \n";
$script_content .= "// 					flag=false; \n";
$script_content .= "// 				} \n";
$script_content .= "// 				if(!((t_ldate!='' && t_udate!='') || (t_ldate == t_udate))) \n";
$script_content .= "// 				{ \n";
$script_content .= "// 					alert('If you want search by release date - interval must be set') \n";
$script_content .= "// 					flag=false; \n";
$script_content .= "// 				} \n";
$script_content .= "				if(flag) \n";
$script_content .= "					form.submit(); \n";
$script_content .= "			} \n";
$doc->addScriptDeclaration($script_content);
?>
<?php
$query = "SELECT max(price+0) FROM #__booklibrary";
$database->setQuery($query);
$max_price = $database->loadResult();
?>
<script type="text/javascript">
       jQuerBook(document).ready(function() {
       jQuerBook("#book_slider").slider({
                min: 0,
                max: <?php echo $max_price; ?>,
                values: [0,<?php echo $max_price; ?>],
                range: true,
                stop: function(event, ui) {
                    jQuerBook("input#pricefrom").val(jQuerBook("#book_slider").slider("values",0));
                    jQuerBook("input#priceto").val(jQuerBook("#book_slider").slider("values",1));
                },
                slide: function(event, ui){
                    jQuerBook("input#pricefrom").val(jQuerBook("#book_slider").slider("values",0));
                    jQuerBook("input#priceto").val(jQuerBook("#book_slider").slider("values",1));
                }
            });

            jQuerBook("input#pricefrom").change(function(){
                var value1=jQuerBook("input#pricefrom").val();
                var value2=jQuerBook("input#priceto").val();
              
                if(parseInt(value1) > parseInt(value2)){
                    value1 = value2;
                    jQuerBook("input#pricefrom").val(value1);
                }
                jQuerBook("#book_slider").slider("values",0,value1);
            });
                  
            jQuerBook("input#priceto").change(function(){
                var value1=jQuerBook("input#pricefrom").val();
                var value2=jQuerBook("input#priceto").val();
                jQuerBook("input#priceto").val(<?php echo $max_price; ?>)
                if(parseInt(value1) > parseInt(value2)){
                    value2 = value1;
                    jQuerBook("input#priceto").val(value2);
                }
                jQuerBook("#book_slider").slider("values",1,value2);
            });  
        });
</script>

<div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">

<table  class="bl_bl_search_books_table_with_logo basictable" border="0" cellpadding="4" 
        cellspacing="0" width="100%">
    <tr>				
        <?php
        if ($currentcat->img != null && $currentcat->align == 'left') {
            ?>
            <td>
                <img src="<?php echo $currentcat->img; ?>" align="<?php echo $currentcat->align; ?>" />
            </td>
            <?php
        }
        ?>
        <td>
            <div class="componentheading">

            <?php if ($params->get('show_page_heading') && $params->get('header') != "" ) {  ?>
                        <h1><?php echo $params->get('header'); ?></h1>
            <?php } else {  ?>
                        <h1><?php echo $currentcat->header ; ?></h1>                
            <?php } ?>

            </div>
        </td>
        <?php
        if ($currentcat->img != null && $currentcat->align == 'right') {
            ?>
            <td>
                <img src="<?php echo $currentcat->img; ?>" 
                     align="<?php echo $currentcat->align; ?>"  alt = "?"/>
            </td>

        <?php } ?>

    </tr>
</table>

    <?php
      $path = "index.php?option=" . $option . "&amp;task=search&amp;Itemid=" . $Itemid;
    ?>

    <form id="adminForm" action="<?php echo sefRelToAbs($path); ?>" method="get" 
          name="com_booklibsearchForm">
        <div  class="bl_advanced_search_table bl_advanced_search_table_free">
              <div class="wrapper_search_keywords_category">
                <div class="wrapper_search_keywords">
                    <span class="span-search-keywords"><?php echo _BOOKLIBRARY_LABEL_SEARCH_KEYWORD; ?>:</span>
                    <input class="inputbox" type="text" name="searchtext" size="20" maxlength="20"/>
                </div>
                <div class="line_search_in wrapper_search_category">
                  <span><?php echo _BOOKLIBRARY_LABEL_CATEGORY; ?>:</span>
                  <?php echo $clist; ?>
                </div>
                </div>



             <span style="display:none;">
                    <input type="checkbox" name="title" checked="checked" />&nbsp;&nbsp;
                    <input type="checkbox" name="isbn" checked="checked" />&nbsp;&nbsp;
                    <input type="checkbox" name="author" checked="checked" />&nbsp;&nbsp;
                    <input type="checkbox" name="description" checked="checked" />&nbsp;&nbsp;
                  <input type="checkbox" name="publisher" checked="checked"/>
             </span> 
            
             <div class="col_box_1">
                <span class="price_label"><?php echo _BOOKLIBRARY_LABEL_PRICE; ?>:</span>
                <div id="book_slider" 
                     class="ui-slider ui-slider-horizontal ui-widget ui-widget-content ui-corner-all">
                </div>
                <div class="pricefrom_2">
                    <span><?php echo _BOOKLIBRARY_SHOW_SEARCH_PRICE_FROM; ?></span>
                    <input type="text" id="pricefrom" name="pricefrom" value="0"/>
                </div>
                <div class="priceto_2">
                    <span><?php echo _BOOKLIBRARY_SHOW_SEARCH_PRICE_TO; ?></span>
                    <input type="text" id="priceto" name="priceto" value="<?php echo $max_price; ?>"/>
                </div>
                <div style="clear: both;"></div>
             </div>
              <div class="line_search_in">
                  <span><?php echo _BOOKLIBRARY_LABEL_CATEGORY; ?>:</span>
                  <?php echo $clist; ?>
              </div>
              <div>
                  <div class="my_btn my_btn-primary bl_advanced_search">
                      <input type="button" onclick="searchsubmit();" 
                              value="<?php echo _BOOKLIBRARY_LABEL_SEARCH_BUTTON; ?>" 
                              class="button bl_advanced_search" />
                  </div>	
                  <input type="hidden" name="option" value="<?php echo $option; ?>">
                  <input type="hidden" name="task" value="search">
                  <input type="hidden" name="Itemid" value="<?php echo $Itemid ?>">
              </div> 
        </div>      
        <br />       
        <?php
        mosHTML::BackButton($params, $hide_js);
        ?>
</form>
</div> <!-- end class componentheading -->
<div style="text-align: center;font-size: 10px;"><a href="https://ordasoft.com/book-library" >Joomla Book Library</a>, by OrdaSoft!</div>
