<?php
/**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
 if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . 
    basename(__FILE__) . ' is not allowed.');


global $doc, $hide_js, $mainframe, $Itemid, $booklibrary_configuration,$database,
  $mosConfig_live_site, $mosConfig_absolute_path, $my, $option;
if(!isset($Itemid)) $Itemid = intval(mosGetParam($_REQUEST, 'Itemid', 0));

require_once ($mosConfig_absolute_path . "/components/com_booklibrary/functions.php");

if( checkJavaScriptIncluded("jQuerBook-1.2.6.js") === false )   {
  $doc->addScript(JURI::root(true) . '/components/com_booklibrary/lightbox/js/jQuerBook-1.2.6.js');
} 
if( checkJavaScriptIncluded("jquery.raty.js") === false )   {
  $doc->addScript(JURI::root(true) . '/components/com_booklibrary/includes/jquery.raty.js');
} 
?>

<noscript>
    Javascript is required to use Book Library 
    <a href="https://ordasoft.com/book-library"
>Book Library - allows create online library for buy ebook</a>,
    <a href="https://ordasoft.com/book-library"
>Joomla book library</a>
</noscript>
 
<script language="javascript" type="text/javascript">

    function review_submitbutton_bl() {
        var form = document.review_bl;
        var rating_checked = false;
        if(form.rating.length) {
        for (c = 0;  c < form.rating.length; c++){
            if (form.rating[c].checked){
                rating_checked = true;
            } 
        }
        } else if(form.rating.value > 0) {
                rating_checked = true;
        }
        if (form.title.value == "") {
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_REVIEW_TITLE; ?>" );
        } else if (form.comment.value == "") {
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_REVIEW_COMMENT; ?>" );
        } else if (!rating_checked) {                
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_REVIEW_RATING; ?>" );
        } else {
            form.submit();
        }
    }
    //*****************   begin add for show/hiden button "Add review" ********************
    function button_hidden( is_hide ) {
        var el  = document.getElementById('button_hidden_review');
        var el2 = document.getElementById('hidden_review_bl');
        if(is_hide){
            el.style.display = 'none';
            el2.style.display = 'inline-flex';
        } else {
            el.style.display = 'inline-flex';
            el2.style.display = 'none';
        }
    }
    //****************   end add for show/hiden button "Add review"   *********************
</script>

<?php

$cat_link_arr = array();
//  var_dump($cat);
//      exit();
foreach($cat as $category) {
    $link = sefRelToAbs('index.php?option=' . $option . '&task=showCategory&catid=' . 
        $category->catid . '&Itemid=' . $Itemid);
    $anchor = "<a href='$link'>{$category->name}</a>";
    $cat_link_arr[] = $anchor;

}
// --

?>
<div class="view_book_layout<?php echo $params->get('pageclass_sfx'); ?>">
<div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">

    <?php if ($params->get('show_page_heading') && $params->get('header') != "" ) {  ?>
                <h1><?php echo $params->get('header'); ?></h1>
    <?php } else {  ?>
                <h1><?php echo $book->title;  ?></h1>                
    <?php } ?>

</div>

<!--end Adding titles for tabs-->

<table  class="basictable bl_view_book my_table" width="100%" cellpadding="4" cellspacing="0" 
        border="0" align="center" 
        class="contentpane<?php echo $params->get('pageclass_sfx'); ?>">
<?php if ($book->title != '') { ?>
        <tr>
            <td nowrap="nowrap" width="15%">       
                <strong><?php echo _BOOKLIBRARY_LABEL_TITLE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
            </td>
            <td><?php echo $book->title; ?></td>
        </tr>
        <tr>
            <td nowrap="nowrap" width="15%">       
                <strong><?php echo _BOOKLIBRARY_CATEGORIES_NAME; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
                <?php echo implode(", ", $cat_link_arr);  ?>
            </td>
        </tr>
        <tr>
            <td nowrap="nowrap" width="15%">       
                <strong><?php echo _BOOKLIBRARY_LABEL_BOOKID; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
            </td>
            <td>
                <?php echo $book->bookid; ?>
            </td>
        </tr>
<?php
}
    if ($book->authors != '' && $authors_info[0]->published != '0') {
?>
        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_AUTHORS; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
            
            <?php
            $i = 1;
            $count = count($authors_info);
            foreach ($authors_info as $author) {
                $link1 = "index.php?option=com_booklibrary&amp;task=view_author&amp;id=" . $author->id . 
                "&amp;Itemid=" . $Itemid;
                ?>
                <a href="<?php echo sefRelToAbs($link1); ?>" 
                    target="_self"><?php echo $author->authors_name; ?></a>
                <?php
                if ($i < $count) echo ", ";
                $i++;
            }
            unset($i);
            unset($count);
            ?>

            </td>
        </tr>

<?php } else { ?>

        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_AUTHORS; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
                <?php echo $book->authors; ?><br />
            </td>
        </tr>
<?php
}
    if ($book->isbn != '') {
?>
        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_ISBN; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
            </td>
            <td>
                <?php echo $book->isbn; ?>
            </td>
        </tr>        
<?php
}
    if ($book->manufacturer != '') {
?>
        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_MANUFACTURER; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
                <?php echo $book->manufacturer; ?>
            </td>
        </tr>
<?php
}
if ($book->release_Date != '') {
?>
        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_PUB_DATE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
            <?php
            //         echo $book->release_Date;
            //         echo "<br>";
            //         echo $booklibrary_configuration['date_format'];
            //         echo "<br>";
    
            ?>
            
    <?php echo $book->release_Date; ?>
    
    
            </td>
        </tr>
            <?php
}
if ($book->edition != '') {
?>
        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_EDITION ; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
                <?php echo $book->edition; ?>
            </td>
        </tr>
<?php
}
    if ($book->numberOfPages != '') {
?>
        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_NUMPAGES ; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
                <?php echo $book->numberOfPages; ?>
            </td>
        </tr>
<?php
}

    if ($book_lang != '') {
?>
        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_LANGUAGE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
    <?php
    echo $book_lang;
?>
            </td>
        </tr>
            <?php
} ?>

        <tr>
            <td nowrap="nowrap">
                <strong><?php echo _BOOKLIBRARY_LABEL_PRICE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
            </td>
            <td>
<?php
    if ($booklibrary_configuration['price_unit_show'] == '1') echo formatMoney($book->price, true, 
        $booklibrary_configuration['price_format']) . " " . $book->priceunit;
    else echo $book->priceunit . " " . formatMoney($book->price, true, 
        $booklibrary_configuration['price_format']);
?>
            </td>
        </tr>

    <tr>
        <td nowrap="nowrap">
            <strong><?php echo _BOOKLIBRARY_LABEL_RATING; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
        </td>
        <td>
            <img src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/rating-<?php echo $book->rating; ?>.png" 
                alt="<?php echo ($book->rating) / 2; ?>" border="0" />&nbsp;
        </td>
    </tr>        
    <tr>
        <td nowrap="nowrap" valign="top">
            <strong><?php echo _BOOKLIBRARY_LABEL_PICTURE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
        </td>
        <td>
<?php
//for local images
$imageURL = $book->imageURL;
if ($imageURL != '' && substr($imageURL, 0, 4) != "http") {
    $imageURL = $mosConfig_live_site . '' . $book->imageURL;;
}
if ($imageURL != '') {
    echo '<img class="bl_view_book_book_image" src="' . $imageURL . '" alt="cover" border="0" height="' . $booklibrary_configuration['foto']['high'] . 
        '" width="' . $booklibrary_configuration['foto']['width'] . '"/>';
} else {
    echo '<img class="bl_view_book_book_image" src="' . $mosConfig_live_site . 
        '/components/com_booklibrary/images/' . _BOOKLIBRARY_NO_PICTURE . 
        '" alt="no-img_eng.png" border="0" height="' . $booklibrary_configuration['foto']['high'] . 
        '" width="' . $booklibrary_configuration['foto']['width'] . '" />';
}
?>


            <!--************   begin add button 'buy now'   ************************-->

<?php
//show button 'buy now'
if ($params->get('show_input_buy_now')) {   
    if ($book->URL != '') {
?>

                    &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
                    <a class="bl_view_book_buy_now my_btn my_btn-success my_btn-large" 
                       href="<?php echo sefRelToAbs($mosConfig_live_site . 
                    "/index.php?option=com_booklibrary&task=new_url&id=" . $book->id . '&Itemid=' . 
                    $Itemid); ?>" target="blank">
                    <!--<img src="<?php echo $mosConfig_live_site; ?>
                        /components/com_booklibrary/images/amazon/buy_now.png" 
                        alt="Button Buy now" border="0" height="27" width="82" />-->
                        <img src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/basket.png" alt="Button Buy now" 
                            border="0" height="27" width="82" />
                            <?php echo _BOOKLIBRARY_ADMIN_CONFIG_BUYNOW ?></a>

<?php
    }
}
?>
 <!--************************   end add button 'buy now'   ******************-->
        </td>
    </tr>
   

<?php
if ($params->get('show_ebooksrequest') && $book->ebookURL != null) {
    $session = JFactory::getSession();
    $sid = $session->getId();
    $session->set("ssmid", $sid);
    setcookie('ssd', $sid, time() + 60 * 60 * 24, "/");
?>
        <tr>
            <td>
                <strong><?php echo _BOOKLIBRARY_LABEL_EBOOK; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td align ="left">
            <?php $j = 0;
            $endFile = '';
            foreach($book->ebookURL as $efile) {
                $endFile = pathinfo($efile->location, PATHINFO_EXTENSION);
                $session->set($efile->id, $efile->id);
            ?>

                <a href="<?php echo sefRelToAbs('index.php?option=com_booklibrary&task=mdownload&id=' . 
                    $book->id . '&Itemid=' . $Itemid . 
                '&efileid=' . $efile->id); ?>" target="blank">
                <?php echo _BOOKLIBRARY_LABEL_EBOOK_DOWNLOAD . ++$j . '.' . $endFile; ?>
                </a></br>
                    
        <?php } ?> 
            </td>
        </tr>  

<?php } ?>


<?php
    if ($book->comment != '') {
?>
        <tr>
            <td valign="top">
                <strong><?php echo _BOOKLIBRARY_LABEL_COMMENT; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
                <?php
    $idesc = $book->comment; //load the desc into a variable
    echo $idesc; //echo new content out
?>
            </td>
        </tr>
            <?php if ($book->owner_id != 0 && $book->ownername != null && $booklibrary_configuration['owner']['show']) { ?>
            <tr>
                <td>
                    <strong><?php echo _BOOKLIBRARY_LABEL_BOOKOWNER; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <?php echo $book->ownername; ?>
                </td>
            </tr>

            <?php } ?>

<?php } ?>
   
   </tr>    
<?php if (!empty($videos)) {
    $youtubeCode = "";
    $videoSrc = array();
    $videoSrcHttp = "";
    $videoType = array();
    foreach($videos as $video) {
        if ($video->youtube) {
            $youtubeCode = $video->youtube;
        } else if ((!empty($video->src))) {
            $videoSrc[] = $video->src;
            $videoType[] = $video->type;
        }
    }
?>
  </tr> 
        <tr>
             <td>
                <strong><?php echo _BOOKLIBRARY_LABEL_VIDEO; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
            </td>
             <td> 
                <?php if (!empty($youtubeCode)) { ?>
                
                <iframe width="420" height="315" frameborder="0" 
                        src="//www.youtube.com/embed/<?php echo $youtubeCode ?>"></iframe> 

                <?php
                    } else if (!empty($videoSrc) && empty($youtubeCode)) { ?>
                     
                    <video width="320" height="240" controls>
                        <?php for ($i = 0;$i < count($videoSrc);$i++) {
                ?>
                    <?php
                    if (!strstr($videoSrc[$i], "http")) {
                        print_r("
                                    <source src=" . $mosConfig_live_site . $videoSrc[$i] . 
                                    " type=" . $videoType[$i] . ">");
                    } else if (strstr($videoSrc[$i], "http")) {
                        print_r("
                            <source src=" . $videoSrc[$i] . " type=" . $videoType[$i] . "> ");
                    } ?>
                
                     <?php } ?> 

                    <?php
                    if (!empty($tracks)) {
                        for ($i = 0;$i < count($tracks);$i++) { ?>
                                   <?php if (!strstr($tracks[$i]->src, "http")) { ?>
                                   <?php print_r("
                                     <track src=" . $mosConfig_live_site . $tracks[$i]->src . 
                                     " kind=" . $tracks[$i]->kind . " srclang=" . 
                                    $tracks[$i]->scrlang . " label=" . $tracks[$i]->label . "> "); ?>
                                  <?php
                            } else if (strstr($tracks[$i]->src, "http")) { ?>   
                                    <?php print_r("
                                     <track src=" . $tracks[$i]->src . " kind=" . $tracks[$i]->kind . 
                                     " srclang=" . $tracks[$i]->scrlang . " label=" . 
                                    $tracks[$i]->label . "> ");
                            }
                        }
                    } 
                    ?>

                    </video>

                <?php } ?> 

            </td>
    </tr>

    <?php } // END video ?>
    
<?php if (!empty($audios)) {
    $audioSrc = array();
    $audioType = array();
    foreach($audios as $audio) {
        if (!empty($audio->src)) {
            $audioSrc[] = $audio->src;
            $audioType[] = $audio->type;
        }
    }
?>
       <tr>
          <td>
              <strong><?php echo _BOOKLIBRARY_LABEL_AUDIO; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
          </td>
          <td>
            <audio controls>
             <?php
                if (!empty($audioSrc)) { 
                    for ($i = 0;$i < count($audioSrc);$i++) {
                        if (!strstr($audioSrc[$i], "http")) { ?>  
                        <?php print_r("
                            <source src=" . $mosConfig_live_site . $audioSrc[$i] . " type=" . 
                            $audioType[$i] . "> ");
                        } else if (strstr($audioSrc[$i], "http")) {
                        print_r("
                          <source src=" . $audioSrc[$i] . " type=" . $audioType[$i] . ">
                        ");
                        } 
                    }
                }
            ?>     
           </audio>           
         </td>
      </tr>

<?php } // END audio ?>

<?php if ($book->id_article_book > 0) { ?>
         <tr>
         <td></td> 
            <td align="left">
               <a class="read_article_book my_btn my_btn-success" href="<?php echo JRoute::_('index.php?option=com_content&view=article&id='.$book->id_article_book.'&Itemid= ' . $Itemid); ?>" target="blank">
                            <?php echo _BOOKLIBRARY_READ_ARTICLE_BOOK_LINK; ?></a>
            </td>
        </tr>
        
    <?php } ?>

<?php  if($book->flipHTML5) { ?>

         <tr>
         <td></td>             
            <td align="left">
                <a class="read_book_online my_btn my_btn-success" href="<?php echo Jroute::_('index.php?option=com_booklibrary&task=read_online&id=' .$book->id .'&format=raw'); ?>" target="_blank">
                        <?php echo _BOOKLIBRARY_READ_BOOK_ONLINE_LINK;?></a>     
            </td>
        </tr>

      <?php } ?>  

</table>


<?php
//lend out??
if ($params->get('show_lendstatus') && $params->get('show_lendrequest')) {
    $data1 = JFactory::getDBO();
    $query = "SELECT  b.lend_from , b.lend_until" .  "\n
              FROM #__booklibrary_lend  AS b LEFT" . "\n
              JOIN #__booklibrary AS c ON b.fk_bookid = c.id 
              WHERE  c.id=" . $book->id . " 
              AND c.published='1' AND c.approved='1' 
              AND b.lend_return IS NULL";
    $data1->setQuery($query);
    $rents1 = $data1->loadObjectList();
?>

<?php
    if (count($rents1) == 0) {
?>
<?php
    } else {
        foreach($rents1 as $rent){
            echo '<div><strong>' . _BOOKLIBRARY_LABEL_LEND_FROM_UNTIL .':</strong></div>' ;
            echo '<div>' . substr($rent->lend_from, 0, 11) . ' / ' . 
                      substr($rent->lend_until, 0, 11) . '</div>';
        }
    }
    if ($params->get('lend_save')) {
        $available = true;
    } else {
        $available = false;
    }
?>
        <br />

<?php
}
?>
<form id="adminForm_bl" action="<?php echo sefRelToAbs("index.php?option=" . $option . 
      "&task=lend_request_bl&is_show_data=1&Itemid=" . $Itemid); ?>" 
      method="post" name="book_bl">
    <table class="bl_view_book_land_request basictable" width="100%">
        <tr>
            <td width="50%" >
            <?php if ($params->get('show_lendrequest') && $params->get('show_lendstatus')) { ?>
                                <div class="my_btn my_btn-primary bl_view_book_land_request_button">
                                    <input type="submit" name="submit" 
                                           value="<?php echo _BOOKLIBRARY_LABEL_BUTTON_LEND_REQU; ?>" 
                                           class="button bl_view_book_land_request_button" 
                                           onclick="document.book_bl.submit()"/>    
                                </div>     

            <?php } ?>

            </td>
            <td width="50%" align="right">
            <?php
                // displays back button
                mosHTML::BackButton($params, $hide_js);
            ?>
            </td>
        </tr>
    </table>
    <input type="hidden" name="bid[]" value="<?php echo $book->id; ?>" />
</form>
    <?php
//sow the reviews
if ($params->get('show_reviews')) {
    $reviews = $book->getReviews();
    
?>
    <br />
    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
        <?php echo _BOOKLIBRARY_LABEL_REVIEWS; ?>
    </div>

<?php
    if ($reviews != null && count($reviews) > 0) {
        for ($m = 0, $n = count($reviews);$m < $n;$m++) {
            $review = $reviews[$m];
            if ($review->published) {
?>
        <div  class="bl_bl_view_book_reviews_table">
                    <div class="line-1">
                            <strong><?php echo $review->title; ?></strong>
                    </div>

                    <div class="line-2">    
                        <?php echo data_transformer($review->date); ?>
                    </div>

                    <div class="line-3">
                        <?php $help = $review->getReviewFrom();
                        echo $help['name']; ?>
                    </div>

                    <div class="line-4">    
                            <img src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/rating-<?php 
                                 echo $review->rating; ?>.png" 
                                 alt="<?php echo ($review->rating) / 2; ?>" border="0"/>
                    </div>

                    <div class="line-5">
                        <?php echo $review->comment; ?>
                    </div>
       </div> 

<?php
        }
    }
} 
?>
    
<?php
    if ($params->get('show_inputreviews')) {
?>
        <!--***********   begin add for show/hiden button "Add review"   ***********************-->
        <div id ="button_hidden_review" class="my_btn my_btn-primary bl_view_book_add_review_button" 
             style="<?php if (isset($_REQUEST['err_msg'])) {
            echo 'display:none'; } ?>">

            <input type="submit" name="submit" 
                   value="<?php echo _BOOKLIBRARY_LABEL_BUTTON_ADD_REVIEW; ?>" 
                   class="button bl_view_book_add_review_button" 
                   onclick="javascript:button_hidden(true)"/>
        </div>
        <!--***********   end add for show/hiden button "Add review"   ************************-->

        <div id="hidden_review_bl" style="<?php if (isset($_REQUEST['err_msg'])) {
            echo 'display:block';
        } else {
            echo 'display:none';
        } ?>">
            <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
                            <?php echo _BOOKLIBRARY_LABEL_ADDREVIEW; ?>
            </div>

            <form id="adminForm" name="review_bl" 
                  action="<?php echo sefRelToAbs("index.php?option=" . $option . 
                  "&task=review_bl&is_show_data=1&Itemid=" . $Itemid); ?>" 
                  method="post" >
                <table class="my_table bl_view_book_add_review_table basictable" width="100%" 
                       cellpadding="4" cellspacing="0" 
                       border="0" align="center" 
                       class="contentpane<?php echo $params->get('pageclass_sfx'); ?>">
                    <tr>
                        <td style="text-align:left;padding:0px;display:inline-block;width:125px;">
                            <?php echo _BOOKLIBRARY_LABEL_REVIEW_TITLE; ?>:&nbsp;
                        </td>                
                        <td style="text-align:left;padding:5px 0px 0px 0px;
                            display:inline-block;width:230px;">                    
                            <input class="inputbox" type="text" name="title" size="80" 
                                   value="<?php if (isset($_REQUEST["title"])) {
                                        echo $_REQUEST["title"]; } ?>" />
                        </td>
                        <td></td>
                    </tr>
                    <tr>
                        <td style="text-align:left;padding:0px;display:inline-block;width:125px;">
                            <?php echo _BOOKLIBRARY_LABEL_REVIEW_COMMENT; ?>
                        </td>
                        <td style="text-align:left;padding:5px 0px 0px 0px;display:inline-block;
                            width:230px;">             
                            <textarea align= "top" name="comment" id="comment" cols="60" rows="10" 
                                      style="width:400;height:100;" 
                                      value="<?php if (isset($_REQUEST["comment"])) {
                            echo $_REQUEST["comment"]; } ?>"/></textarea>
                        </td>
                    </tr>
                    <tr>
                      <td style="display:inline-block;width:125px;">
                    <script type="text/javascript">
                        os_img_path = '<?php echo $mosConfig_live_site . 
                            '/components/com_booklibrary/images/'; ?>' ;
                        jQuerBook(document).ready(function(){
                            jQuerBook('#star').raty({
                                starHalf: os_img_path+'star-half.png',
                                starOff: os_img_path+'star-off.png',
                                starOn: os_img_path+'star-on.png' 
                            });
                        });
                    </script>
                            <span class="lable_rating">
                                <?php echo _BOOKLIBRARY_LABEL_REVIEW_RATING; ?></span>
                        </td>
                        <td style="display:inline-block;">
                            <span id="star"></span>
                        </td>
                    </tr>
                       
                    <!--*********************   begin add antispam guest   *********************-->
    <?php 
        $user_guest = userGID_BL($my->id);
        if ((int)$user_guest == - 2) {
    ?>
                        <tr>
                            <td colspan="2">
                                <!--********************   begin insetr image   *****************-->
        <?php
            //    @session_start();
            // begin create kod
            $st = "      ";
            $algoritm = mt_rand(1, 2);
            switch ($algoritm) {
                case 1:
                    for ($j = 0;$j < 6;$j+= 2) {
                        $st = substr_replace($st, chr(mt_rand(97, 122)), $j, 1); //abc
                        $st = substr_replace($st, chr(mt_rand(50, 57)), $j + 1, 1); //23456789
                        
                    }
                    break;
                case 2:
                    for ($j = 0;$j < 6;$j+= 2) {
                        $st = substr_replace($st, chr(mt_rand(50, 57)), $j, 1); //23456789
                        $st = substr_replace($st, chr(mt_rand(97, 122)), $j + 1, 1); //abc
                        
                    }
                    break;
                }
                //*************   begin search in $st simbol 'o, l, i, j, t, f'   *******************
                $st_validator = "olijtf";
                for ($j = 0;$j < 6;$j++) {
                    for ($i = 0;$i < strlen($st_validator);$i++) {
                        if ($st[$j] == $st_validator[$i]) {
                            $st[$j] = chr(mt_rand(117, 122)); //uvwxyz
                            
                        }
                    }
                }
                //**************   end search in $st simbol 'o, l, i, j, t, f'   *******************
                $session = JFactory::getSession();
                $session->set('captcha_keystring', $st);
                if (isset($_REQUEST['error']) && $_REQUEST['error'] != "") 
                    echo "<font style='color:red'>" . $_REQUEST['error'] . "</font><br />";
                $name_user = "";
                if (isset($_REQUEST['name_user'])) $name_user = $_REQUEST['name_user'];
                if (isset($_REQUEST["err_msg"])) echo "<script> alert('Error: " . 
                    $_REQUEST["err_msg"] . "'); </script>\n";
                echo "<br /><img src='" . $mosConfig_live_site .
                                                "/index.php?option=com_booklibrary&amp;" . 
                    "task=secret_image&Itemid=$Itemid" . "' alt='CAPTCHA_picture'/><br/>";
        ?>
                                <!--**********************   end insetr image   *******************-->
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">&nbsp;

                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">
                                <?php echo _BOOKLIBRARY_LABEL_REVIEW_KEYGUEST; ?>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2">
                                <input class="inputbox" type="text" name="keyguest" size="6" 
                                       maxlength="6" />
                            </td>

                        </tr>

    <?php } ?>

                    <!--****************   end add antispam guest   ******************************-->
                    <tr>
                        <td class="bl_suggestion_save">
                            <!-- save review button-->
                            <input class="button my_btn my_btn-success" type="button" 
                                   value="<?php echo _BOOKLIBRARY_LABEL_BUTTON_SAVE; ?>" 
                                   onclick="review_submitbutton_bl()"/>                        
                        </td>
                        <td class="bl_suggestion_hide">
                            <!-- hifde review button-->
                            <input class="button my_btn my_btn-info" type="button" 
                                   value="<?php echo _BOOKLIBRARY_LABEL_BUTTON_REVIEW_HIDE; ?>" 
                                   onclick="javascript:button_hidden(false);"/>                        
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2">&nbsp;
                        </td>
                    </tr>
                </table>
                <input type="hidden" name="fk_bookid" value="<?php echo $book->id; ?>" />
                <input type="hidden" name="catid" value="<?php echo $catid[0]->id; ?>" />
            </form>
        </div> <!-- end <div id="hidden_review_bl"> -->
        <br />
        <br />
        <?php
        }
    } ?>
    </div>
<div style="text-align: center;font-size: 10px;"><a href="https://ordasoft.com/book-library" >Joomla Book Library</a>, by OrdaSoft!</div>

