<?php
/**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.
  basename(__FILE__).' is not allowed.' );
global $mosConfig_absolute_path, $mosConfig_lang,$mosConfig_live_site;
require('./components/com_booklibrary/admin.booklibrary.class.conf.php');
// load language 
if (file_exists($mosConfig_absolute_path."/components/com_booklibrary/language/{$mosConfig_lang}.php" )) {
  include_once($mosConfig_absolute_path."/components/com_booklibrary/language/{$mosConfig_lang}.php" );
} else {
  include_once($mosConfig_absolute_path."/components/com_booklibrary/language/English.php" );
}
// $start = microtime(true);
$xml = simplexml_load_file($mosConfig_absolute_path . "/administrator/components/com_booklibrary/booklibrary.xml");
$version = (string)$xml->version;
$creationDate = (string)$xml->creationDate;
unset($xml);
// $time = microtime(true) - $start;
// printf('Скрипт выполнялся %.4F сек.', $time);
?>
<table class="adminform bl_admin_about_tab_releasenote my_table">
  <tr>
    <td colspan="2">
      <h3><?php echo _BOOKLIBRARY_DOC_GENERAL_INFO;?></h3>
    </td>
  </tr>
  <tr>
    <td>
      <strong> <?php echo _BOOKLIBRARY_DOC_VERSION;?></strong>
    </td>
    <td>
      <?php if ($booklibrary_configuration['release']['version'] == $version) { ?>
      <strong>v <?php echo $booklibrary_configuration['release']['version'];?></strong>
      <?php } else { ?>
      <strong>v <?php echo $version;?></strong>
      <?php } ?>
    </td>
  </tr>
  <tr>
    <td>
      <strong><?php echo _BOOKLIBRARY_DOC_RELEASE_DATE;?></strong>
    </td>
    <td>
      <?php if ($booklibrary_configuration['release']['date'] == $creationDate) { ?>
      <strong><?php echo $booklibrary_configuration['release']['date'];?></strong>
      <?php } else { ?>
      <strong><?php echo $creationDate;?></strong>
      <?php } ?>
    </td>
  </tr>
  <tr>
    <td>
      <strong><?php echo _BOOKLIBRARY_DOC_PROJECTLINK;?></strong>
    </td>
    <td>
      <strong>
        <a href="//www.ordasoft.com" target="blank">www.ordasoft.com</a>
      </strong>
    </td>
  </tr>
  <tr>
    <td>
      <strong><?php echo _BOOKLIBRARY_DOC_PROJECT_HOST;?></strong>
    </td>
    <td>
      <strong>Andrey Kvasnevskiy (<a href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)
      </strong>
    </td>
  </tr>
  <tr>
    <td valign="top">
      <strong><?php echo _BOOKLIBRARY_DOC_LICENSE;?></strong>
    </td>
    <td>
      <strong>
        <a href="<?php echo $mosConfig_live_site.
          "/administrator/components/com_booklibrary/doc/LICENSE.txt"; ?>" 
           target="blank">License</a>
      </strong>
      <br />
       <?php echo _BOOKLIBRARY_DOC_WARRANTY;?>
    </td>
  </tr>
  <tr>
    <td valign="top">
      <strong>README:</strong>
    </td>
    <td>
      <strong>
        <a href="<?php echo $mosConfig_live_site.
          "/administrator/components/com_booklibrary/doc/README.txt"; ?>" 
           target="blank">README</a>
      </strong>
    </td>
  </tr>
  <tr >
    <td valign="top">
      <strong><?php echo _BOOKLIBRARY_DOC_DEVELOP;?></strong>
    </td>
    <td>
        <li><b>v 6.2 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 6.1 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 6.0 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 5.1 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 5.0 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>); Vitalii Savytskyi</li>
        <li><b>v 4.0 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>); Dmitry Smirnov(<a href="mailto:dmitriiua21@gmail.com" >dmitriiua21@gmail.com</a>)</li>
        <li><b>v 3.6 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>); Dmitry Smirnov(<a href="mailto:dmitriiua21@gmail.com" >dmitriiua21@gmail.com</a>)</li>
        <li><b>v 3.5 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 3.1 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 3.0 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 2.2 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 2.1 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 2.0 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 1.5.3.1 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 1.5.3 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>);Aleksey Pakholkov</li>
        <li><b>v 1.5.2.4 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>);Aleksey Pakholkov</li>
        <li><b>v 1.5.2.3 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 1.5.2.2 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 1.5.2.1 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 1.5.2 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 1.0.2 </b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>)</li>
        <li><b>v 1.0.1</b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>), Nikolay Salionovych(<a 
            href="mailto:salionovych@ukr.net" >salionovych@ukr.net</a>)</li>
        <li><b>v 1.0</b> - Orda Soft: Andrey Kvasnevskiy(<a 
          href="mailto:akbet@ordasoft.com" >akbet@ordasoft.com</a>), Nikolay Salionovych(<a 
            href="mailto:salionovych@ukr.net" >salionovych@ukr.net</a>)</li>
        <li><b>v 0.7</b> - Andrzej Waland (<a 
          href="www.waland.pl/mambo" target="blank">www.waland.pl/mambo</a>), Leon Treff (<a 
          href="mailto:treff@pt.lu" >treff@pt.lu</a>) </li>
        <li><b>v 0.6</b> - Gerd Saurer <a 
          href="//www.sapoba.com/~gerd/" 
          target="blank"><?php echo _BOOKLIBRARY_DOC_HOMEPAGE;?></a> (<a 
          href="mailto:goertsch@user.mamboforge.net" >goertsch@user.mamboforge.net</a>) </li>
    </td>
  </tr>
</table>
