<?php
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . 
    basename(__FILE__) . ' is not allowed.');
/**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
jimport('joomla.plugin.helper');
jimport('joomla.html.toolbar');
require_once ($mosConfig_absolute_path . "/components/com_booklibrary/booklibrary.php");
//require_once ($mosConfig_absolute_path . "/administrator/components/com_booklibrary/menubar_ext.php");
$mosConfig_live_site = JURI::root(true); 
$GLOBALS['mosConfig_live_site'] = $mosConfig_live_site;
$GLOBALS['mosConfig_absolute_path'] = $mosConfig_absolute_path; 

$mainframe = JFactory::getApplication();
$GLOBALS['mainframe'] = $mainframe;
$templateDir = JPATH_THEMES . DS . JFactory::getApplication()->getTemplate() . DS;
$GLOBALS['templateDir'] = $templateDir;
$doc = JFactory::getDocument();
$GLOBALS['doc'] = $doc;
$doc->addStyleSheet('//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css');
// --
$g_item_count = 0;

class HTML_booklibrary {
    static function sort_head($title, $fieldname, $sort_arr, $fb = true) {
        global $mosConfig_live_site, $Itemid;
        global $templateDir; 
        global $mosConfig_absolute_path; 
        $att_str = '';
        $ext_str = '';
        if ($fb) {
            if (array_key_exists('task', $_REQUEST)) {
                $ext_str.= '&task=' . $_REQUEST['task'];
                if ($_REQUEST['task'] == 'search') $att_str = '&searchtext=&searchtype=simplesearch';
            } else if (array_key_exists('view', $_REQUEST)) {
                $ext_str.= '&task=' . $_REQUEST['view'];
                if ($_REQUEST['view'] == 'search') $att_str = '&searchtext=&searchtype=simplesearch';
            }
            if (array_key_exists('catid', $_REQUEST)) {
                $ext_str.= '&catid=' . $_REQUEST['catid'];
            }
            if (array_key_exists('limitstart', $_REQUEST)) {
                $ext_str.= '&limitstart=' . $_REQUEST['limitstart'];
            }
            if (array_key_exists('sp', $_REQUEST)) {
                $ext_str.= '&sp=' . $_REQUEST['sp'];
            }
        }
        $img_str = "";
        if ($sort_arr['field'] == $fieldname) {
            if ($sort_arr['direction'] == '') {
                $templateDir = substr($templateDir, strpos($templateDir, "templat")); 
                $path = "$mosConfig_absolute_path/$templateDir" . "images/plus.png"; 
                $p = JURI::base() . "components/com_booklibrary/" . "images/uparrow-1.png"; 
                $img_str = "<img src='$p' width=\"12\" height=\"12\" border=\"0\" 
                    alt='Sorted up' style='margin:-2px 4px 0 0;' />";
                $str = "<a href='" . $mosConfig_live_site . 
                    "/index.php?option=com_booklibrary$ext_str&sortup=$fieldname&Itemid=$Itemid" . 
                    $att_str . "'>" . $img_str . $title . "</a>";
            } else {
                $templateDir = substr($templateDir, strpos($templateDir, "templat")); 
                $path = "$mosConfig_absolute_path/$templateDir" . "images/minus.png"; 
                $p = JURI::base() . "components/com_booklibrary/" . "images/downarrow-1.png"; 
                $img_str = "<img src='$p' width=\"12\" height=\"12\" border=\"0\" 
                    alt='Sorted down' style='margin:-2px 4px 0 0;' />";
                $str = "<a href='" . $mosConfig_live_site . 
                    "/index.php?option=com_booklibrary$ext_str&sortdown=$fieldname&Itemid=$Itemid" . 
                    $att_str . "'>" . $img_str . $title . "</a>";
            }
        } else {
            $str = $str = "<a href='" . $mosConfig_live_site . 
                "/index.php?option=com_booklibrary$ext_str&sortdown=$fieldname&Itemid=$Itemid" . 
                $att_str . "'>" . $title . "</a>";
        }
        return $str;
    }
    static function showLendRequest(&$books, &$currentcat, &$params, &$tabclass, &$catid, 
                                    &$sub_categories, $is_exist_sub_categories, $sort_arr) {
        HTML_booklibrary::displayBooks($books, $currentcat, $params, $tabclass, $catid, 
                                       $sub_categories, $is_exist_sub_categories, $sort_arr);
        // add the formular for send to :-)
        
    }
    static function displayBooks($rows, $currentcat, &$params, $tabclass, $catid, $categories, 
                                 $is_exist_sub_categories, $sort_arr, $list_str = array(), 
                                 &$pageNav = null, $layout = "list", $cat_name = "", $authors_info=array()) {
        global $mosConfig_absolute_path, $booklibrary_configuration, $my, $acl, $option, $doc,$database,$Itemid;

        /*      if ($booklibrary_configuration['cb_mybook']['show'] == '1' 
                    && checkAccessBL($booklibrary_configuration['cb_mybook']['registrationlevel'], 
                    'NORECURSE', userGID_BL($my->id), $acl))
                        echo "<span class='books_button'><a class='my_btn my_btn-primary' 
                        href='" . JRoute::_('index.php?option=' . $option . 
                        '&task=show_my_books&layout=mybooks') . "'>" . 
                        _BOOKLIBRARY_LABEL_CBBOOKS_TT . "</a></span>";
                
        if(($booklibrary_configuration['cb_edit']['show'])=='1' 
            && checkAccessBL($booklibrary_configuration['cb_mybook']['registrationlevel'], 
            'NORECURSE', userGID_BL($my->id), $acl))
                echo " <span class='books_button'><a class='my_btn my_btn-primary'
                href='" . JRoute::_('index.php?option='.$option.'&task=showmybooks&layout=mybooks') . 
                "'>" . _BOOKLIBRARY_LABEL_CBEDIT . "</a></span>";
        */
       $type =  $params->get('type');
        if ($layout == null) $layout = "list";
         if(!empty($type )) {
            $type = 'books';    
         } else {
            $type = 'showCategory';
         }  

        $menu = new JTableMenu($database);
        $menu->load($Itemid);
        $menu_params = new JRegistry;
        $menu_params->loadString($menu->params);
        $allcategorylayout = $menu_params->get('allcategorylayout', 'default');
        // echo "1111111111111111111:".$type;
        // print_r($params);
        if($allcategorylayout == "list" ) $one_item_layout = "_one_item2" ;
        else $one_item_layout = "_one_item1" ;

        require getLayoutPathBook::getLayoutPathCom('com_booklibrary', $type, $layout);
        /*require($mosConfig_absolute_path . 
            "/components/com_booklibrary/views/showCategory/tmpl/" . $layout . ".php");*/
        
    }    
    /**
     * Displays simple search
     * Lend Status
     */
    //----------------------------------------------------------------------
    static function displayBooksPrint($rows, $currentcat, &$params, $tabclass, $catid, 
                                      $categories) {
        global $hide_js, $Itemid, $mosConfig_live_site, $mosConfig_absolute_path;
        global $limit, $total, $limitstart, $task, $paginations, $mainframe, 
               $booklibrary_configuration;

        $session = JFactory::getSession();
        $arr = $session->get("array", "default");
    ?>
    <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />
        </head>
        <body>
        <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
            <table class="basictable this10">
                <tr>
                    <td>
                    <?php
                        if (!$params->get('wrongitemid')) {
                            echo $currentcat->header;
                        } else {
                            $parametrs = $mainframe->getParams();
                            echo $parametrs->_registry['_default']['data']->page_title;
                        }
                    ?>
                    </td>
                    <td align="right">
                 
                            <a href="#" onclick="window.print();return false;">
                            <img src="<?php echo $mosConfig_live_site; ?>/media/system/images/printButton.png" 
                                 alt="Print"  /></a>
            
                    </td>
                </tr>      
            </table>
        </div>

        <div id="list">
            <table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr>
                    <td height="20" class="sectiontableheader<?php 
                        echo $params->get('pageclass_sfx'); ?>">
                        <?php echo _BOOKLIBRARY_LABEL_COVER; ?>
                    </td>
                    <td height="20" class="sectiontableheader<?php 
                        echo $params->get('pageclass_sfx'); ?>">
                        <?php echo _BOOKLIBRARY_LABEL_TITLE; ?>
                    </td>
                    <td height="20" class="sectiontableheader<?php 
                        echo $params->get('pageclass_sfx'); ?>">
                        <?php echo _BOOKLIBRARY_LABEL_AUTHORS; ?>
                    </td>

                    <?php
                        if ($params->get('show_rating')) {
                    ?>
                        <td height="20" class="sectiontableheader<?php 
                            echo $params->get('pageclass_sfx'); ?>">
                            <?php echo _BOOKLIBRARY_LABEL_RATING; ?>
                        </td>
                    <?php
                        }
                        if ($params->get('hits')) {
                    ?>
                        <td width="30" height="20" 
                            class="sectiontableheader<?php echo $params->get('pageclass_sfx'); ?>" 
                            align="right">
                            <?php echo _BOOKLIBRARY_LABEL_HITS; ?>
                        </td>
                    <?php
                        }
                        if ($params->get('show_lendstatus') && $params->get('show_lendrequest')) {
                    ?>
                        <td height="20" 
                            class="sectiontableheader<?php echo $params->get('pageclass_sfx'); ?>">    
                            <?php echo _BOOKLIBRARY_LABEL_LEND_CB; ?>
                        </td>
                    <?php
                        }
                    ?>
                </tr>
    <?php
        $available = false;
        $k = 0;
        foreach($rows as $row) {
            $link = 'index.php?option=com_booklibrary&amp;task=view_bl&amp;id=' . $row->id . 
                '&amp;catid=' . $catid . '&amp;Itemid=' . $Itemid;
    ?>            
                    <tr class="<?php echo $tabclass[$k]; ?>" >
                        <td style="padding-left:5px; padding-top:5px; padding-right:10px;">
        <?php
            $book = $row;
            if ($book->URL != '') {
                echo '<a href="';
                echo $book->URL;
                echo '"  target="blank"></a>';
            }
            //for local images
            $imageURL = $book->imageURL;
            if ($imageURL != '' && substr($imageURL, 0, 4) != "http") {
                $imageURL = $mosConfig_live_site . $book->imageURL;;
            }
            if ($imageURL != '') {
                echo '<img src="';
                echo $imageURL;
                echo '" alt="cover" border="0" height="50" />&nbsp;';
            } else {
                echo '<img src="' . $mosConfig_live_site . '/components/com_booklibrary/images/';
                echo _BOOKLIBRARY_NO_PICTURE;
                echo '" alt="no-img_eng.png" border="0" />&nbsp;';
            }
        ?>
                        </td>
                        <td  width="45%">
                            <a href="<?php echo sefRelToAbs($link); ?>" 
                               class="category<?php echo $params->get('pageclass_sfx'); ?>">
            <?php echo $row->title; ?> 
                            </a> 
                            <!--<?php if ($params->get('item_description')) { ?>
                            <br /> 
                                <?php echo $row->description; ?>

                            <?php } ?>-->

                        </td>
                        <td  width="10%">
                            <?php
                                if(is_array($row->authors) ){
                                foreach ($row->authors as $author) {
                                    echo $author;
                                 } 
                                } else echo $row->authors; 
                            ?> 
                        </td>

                        <?php if ($params->get('show_rating')) { ?>
                            <td align="right"> 
                                <img src="<?php echo JURI::root(); ?>components/com_booklibrary/images/rating-<?php echo $row->rating; ?>.png" 
                                    alt="<?php echo ($row->rating) / 2; ?>" align="left" 
                                    border="0" />&nbsp;&nbsp;
                            </td>

                        <?php } if ($params->get('hits')) { ?>

                            <td align="left">
                                <?php echo $row->hits; ?>
                            </td>
                        <?php
                        }
                        if ($params->get('show_lendstatus') && $params->get('show_lendrequest')) {
                            $data1 = JFactory::getDBO();
                            $query = "SELECT  b.lend_from , b.lend_until 
                                      FROM #__booklibrary_lend  AS b 
                                      LEFT JOIN #__booklibrary AS c ON b.fk_bookid = c.id 
                                      WHERE  c.id=" . $row->id . " AND c.published='1' 
                                      AND c.approved='1' AND ( b.lend_return = '0000-00-00 00:00:00' or b.lend_return is null )  ";
                            $data1->setQuery($query);
                            $rents1 = $data1->loadObjectList();
                        ?>
                            <td align="center">

                        <?php if (count($rents1) == 0) { ?>

                        <?php echo "<img src='" . JURI::root() . 
                            "components/com_booklibrary/images/ok.png' alt='Available' 
                            name='image' border='0' align='middle' />";
                        } else {
                            echo _BOOKLIBRARY_LABEL_LEND_FROM_UNTIL . "<br />";
                            for ($a = 0;$a < count($rents1);$a++) {
                            $from_until = substr($rents1[$a]->lend_from, 0, 10) . "&nbsp;/&nbsp;" . 
                                substr($rents1[$a]->lend_until, 0, 10) . "\n";
                            print_r($from_until);
                            }
                        }
                        ?>
                                <br>
                            </td>

                        <?php } ?>

                        </tr>
                        <?php
                            $k = 1 - $k;
                        }
                        ?>
                <tr><td colspan="6" align="center">&nbsp;</td></tr>
            </table>
        </div>
        </body>
    <?php
         exit; // this exit needs to this function works correctly
        
    }
    //--------------------------------------------------------------------------------------------
    static function displaySimpleSearch() {
        global $Itemid, $mosConfig_live_site;
    ?>
        <!-- <?php
        $path = "index.php?option=" . $option . "&amp;task=search_book&amp;Itemid=" . $Itemid;
        ?> --> 


        <form class="my_form-search bl_bl_all_categories_top_search" id="adminForm" 
              name="simlesearchform" action="<?php echo sefRelToAbs($path); ?>"  method="get">
            <div class="my_input-append">
                <input class="my_search-query" type="text" name="searchtext" value=""/><button 
                      type="submit" class="my_btn">
                    <a href="javascript:document.simlesearchform.submit();" >
                        <img src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/search.gif" alt="Search" 
                            title="Search" />
                    </a>
                </button>    
                <input type="hidden" name="option" value="com_booklibrary">
                <input type="hidden" name="task" value="search">
                <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>">
                <input type="hidden" name="searchtype" value="simplesearch">
            </div>
        </form>
    <?php
    }
    //--------------------------------------------------
    static function displayMediaBook(&$book, &$params) {
        global $booklibrary_configuration, $mosConfig_live_site, $Itemid;
        $jinput = JFactory::getApplication()->input;
        $printItem = $jinput->get('printItem');
        JPluginHelper::importPlugin('content');
        // Class 'JDispatcher' not found: JDispatcher deprecated J >= 4.0. Use JFactory::getApplication()->triggerEvent(...) instead
        // $dispatcher = JDispatcher::getInstance();
    ?>



        <?php if (trim($book->title)) { ?>

            <tr>
                <td nowrap="nowrap" width="20%" align="right">       
                    <strong><?php echo _BOOKLIBRARY_LABEL_TITLE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php echo $book->title; ?>
                </td>
            </tr>

        <?php } ?>

        <tr>
            <td nowrap="nowrap" width="20%" align="right">
                <strong><?php echo _BOOKLIBRARY_LABEL_BOOKID; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </strong>
            </td>
            <td>
        <?php echo $book->bookid; ?>
            </td>
        </tr>
        <?php if (trim($book->authors)) { ?>

            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_AUTHORS; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php echo $book->authors; ?>
                </td>
            </tr>
            <?php
                }
                if (trim($book->isbn)) {
            ?>
            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_ISBN; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <?php echo $book->isbn; ?>
                </td>
            </tr>   
            <?php
            }
                if (trim($book->manufacturer)) {
            ?>
            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_MANUFACTURER; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php echo $book->manufacturer; ?>
                </td>
            </tr>

            <?php
            }
                if (trim($book->edition)) {
            ?>
            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_EDITION; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php echo $book->edition; ?>
                </td>
            </tr>

            <?php
            }
                if ($book->numberOfPages != '') {
            ?>
            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_NUMPAGES; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <?php echo $book->numberOfPages; ?>
                </td>
            </tr>
            <?php
            }
                if (trim($book->language)) {
            ?>
            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_LANGUAGE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <?php
                    echo $book->language; //old ENGLISH strtoupper($book->language);
                    ?>
                </td>
            </tr>
            <?php
            }
                if (trim($book->featured_clicks)) {
            ?>        
            <tr>
                <td nowrap="nowrap" align="right" class="title_td">
                    <strong><?php echo _BOOKLIBRARY_LABEL_FEATURE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php echo $book->featured_clicks; ?>
                </td>
            </tr>
            <?php
            }
                if (trim($book->featured_shows)) {
            ?>       
             <tr>
                <td nowrap="nowrap" align="right" class="title_td">
                    <strong><?php echo _BOOKLIBRARY_LABEL_SHOWS; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php echo $book->featured_shows; ?>
                </td>
            </tr>
            <?php
            }
                if ($params->get('show_price') == '1') {
            ?>
            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_PRICE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <?php echo $book->price; ?>&nbsp;&nbsp; <?php echo $book->priceunit; ?>
                </td>
            </tr>
            <?php
                }
                    if (trim($book->language)) {
            ?>
            <tr>
                <td nowrap="nowrap" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_RATING; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <img src="<?php echo JURI::root(); ?>/components/com_booklibrary/images/rating-<?php echo $book->rating; ?>.png" 
                        alt="<?php echo ($book->rating) / 2; ?>" border="0" />&nbsp;
                </td>
            </tr>

            <?php
                }
                    if (trim($booklibrary_configuration['foto']['high']) || trim($book->imageURL)) {
            ?>
            <tr>
                <td nowrap="nowrap" align="right" valign="top">
                    <strong><?php echo _BOOKLIBRARY_LABEL_PICTURE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php
                    //for local images
                    $imageURL = $book->imageURL;
                    if ($imageURL != '' && substr($imageURL, 0, 4) != "http") {
                        $imageURL = $mosConfig_live_site . $imageURL;;
                    }
                    if ($imageURL != '') {
                        echo '<img src="' . $imageURL . '" alt="cover" border="0" height="' . 
                            $booklibrary_configuration['foto']['high'] . 
                            '" width="' . $booklibrary_configuration['foto']['width'] . '"/>';
                    } else {
                        /*echo '<img src="'.$mosConfig_live_site.'/components/com_booklibrary/images/' . 
                            _BOOKLIBRARY_NO_PICTURE.'" alt="no-img_eng.png" border="0" />';*/
                        
                    }
                }
            ?>


                <!--************   begin add button 'buy now'   ************************-->

            <?php
            //show button 'buy now'
            if ($params->get('show_input_buy_now') && $book->informationFrom == 1) {
                if ($book->URL != '') {
            ?>
                        &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
                        <!--a href="<?php echo sefRelToAbs($mosConfig_live_site . 
                            "/index.php?option=com_booklibrary&amp;task=new_url&amp;id=" . 
                            $book->id); ?>" target="blank">
                            <img src="<?php echo JURI::root(); ?>
                            /components/com_booklibrary/images/amazon/buy_now.png" 
                            alt="Button Buy now" 
                            border="0" height="27" width="82" />
                        </a-->
        <?php
        }
            }
        ?>

        <!--************************   end add button 'buy now'   ******************-->
         
            </td>
        </tr>

        <?php
        if ($params->get('show_emedisrequest') && $book->ebookURL != null) {
            $session = JFactory::getSession();
            $sid = $session->getId();
            $session->set("ssmid", $sid);
            setcookie('ssd', $sid, time() + 60 * 60 * 24, "/");
        ?>
            <tr>
                <td align="right" >
                    <strong><?php echo _BOOKLIBRARY_LABEL_EMEDIA; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td align ="left">  
                    <a href="<?php 
                        echo sefRelToAbs('index.php?option=com_booklibrary&task=mdownload&id=' .
                        $book->id); ?>" target="blank">
                    <?php echo _BOOKLIBRARY_LABEL_EMEDIA_DOWNLOAD; ?>
                    </a>
                </td>
            </tr> 

        <?php } ?>

        <?php
        //lend out??
        if ($params->get('show_lendstatus') && $params->get('show_lendrequest')) {
            $lend = $book->getAllLends();
            $num = count($lend);
            if ($num > 0) {
        ?>

                <tr>
                    <td align="right" valign="top">
                        <strong><?php echo _BOOKLIBRARY_LABEL_LEND_FROM_UNTIL; ?>:</strong>
                    </td>
                    <td></td>
                </tr>

            <?php
                for ($e = 0, $m = count($lend);$e < $m;$e++) {
                    print (" <tr><td align=\"left\">&nbsp;</td><td> ");
                    $date = substr($lend[$e]->lend_from, 0, 10) . "      " . 
                    substr($lend[$e]->lend_until, 0, 10);
                    print_r($date);
                    print (" </td></tr>");
                }
            }
            }
            if (trim($book->comment)) {
            ?>              
            <tr>
                <td align="right" valign="top">
                    <strong><?php echo _BOOKLIBRARY_LABEL_COMMENT; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <?php
                        $err_state = ini_get('display_errors');
                        ini_set('display_errors', 'Off');
                        $idesc = $book->comment; //load the desc into a variable
                        $plug_row = new stdClass();
                        $plug_row->text = $idesc; // load the var into plugin_row object
                        // Class 'JDispatcher' not found: JDispatcher deprecated J >= 4.0. Use JFactory::getApplication()->triggerEvent(...) instead
                        // $offset = 0;
                        $plug_params = 1;
                        // $results = $dispatcher->trigger('onContentPrepare', array('com_booklibrary', &$plug_row, &$plug_params, $offset)); /*run mambot onPrepareContent on plug_row object*/
                        // Trigger the onContentPrepare event.
                        JFactory::getApplication()->triggerEvent('onContentPrepare', array("com_booklibrary", $plug_row, $plug_params));
                        $idesc = $plug_row->text; //get new content from plug_row object to value
                        echo $idesc; //echo new content out
                        ini_set('display_errors', $err_state);
                    ?>
                </td>
            </tr>

            <?php } ?>

            <?php if ($book->owner_id != '' && $book->ownername != null && $booklibrary_configuration['owner']['show']) { ?>
            <tr>
                <td align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_BOOKOWNER; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
            <?php echo $book->ownername; ?>
                </td>
            </tr>
        <?php
        } ?>
        <?php
    }
    //-----------------------------------------------------------------------------
    static function displayAuthor(&$authors, $params, $rows, $author_description,$books_titles) {
       //print_r("i am here!");exit;

        global $mosConfig_absolute_path;
        $layout = "default";
        $type = 'view_author';
        require getLayoutPathBook::getLayoutPathCom('com_booklibrary', $type, $layout);
    }
    static function displayAuthors($all_authors, $pageNav, $params, $layout, $list_str) {
        global $mosConfig_absolute_path;
        if ($layout == '') $layout = "default";
        $type = 'all_authors';
        require getLayoutPathBook::getLayoutPathCom('com_booklibrary', $type, $layout);
    }
    static function displayBook(&$book, &$tabclass, &$params, &$currentcat, &$cat, &$rating, 
                                $book_lang, $id, $catid, $authors_book, $authors_info, $videos, 
                                $audios, $tracks, $layout /* = "default" */
    ) {
        global $mosConfig_absolute_path;
        if ($layout == '') $layout = "default";
        $type = 'view_book';

        require getLayoutPathBook::getLayoutPathCom('com_booklibrary', $type, $layout);
        /*require($mosConfig_absolute_path . "/components/com_booklibrary/views/view_book/tmpl/" . 
            $layout . ".php");*/
        
    }
    /**
     * Display links to categories
     */
    static function showCategories(&$params, &$categories, &$catid, &$tabclass, 
                                   &$currentcat, $layout = "default") {
        global $mosConfig_absolute_path;
        $type = 'categories';
        
        require getLayoutPathBook::getLayoutPathCom('com_booklibrary', $type, $layout);
        /*require($mosConfig_absolute_path . "/components/com_booklibrary/views/categories/tmpl/" . 
            $layout . ".php"); */
        
    }
    static function showMyBooksButton() {
        global $mosConfig_live_site, $Itemid;
?>
        <form class="bl_bl_all_categories_show_book" id="adminForm" action="<?php echo sefRelToAbs("index.php?option=com_booklibrary&task=show_my_books&Itemid=" . 
            $Itemid); ?>" method="get" name="ownerslist">
            <div class="bl_bl_show_my_books_div my_btn my_btn-primary">
                <input  class="bl_bl_show_my_books" type="submit" name="submit" 
                        value="<?php echo _BOOKLIBRARY_LABEL_CBBOOKS_TT; ?>" class="button"/>
            </div>
        </form>
        <?php
    }
    static function showOwnersButton() {
        global $mosConfig_live_site, $Itemid;
    ?>

        <form class="bl_bl_all_categories_owners_list" id="adminForm" 
        action="<?php echo sefRelToAbs("index.php?option=com_booklibrary&amp;".
            "task=owners_list&amp;Itemid=" . $Itemid); ?>" method="post" name="ownerslist">
            <div class="bl_bl_owners_list_div my_btn my_btn-primary">
                <input  class="bl_bl_owners_list" type="submit" name="submit" 
                      value="<?php echo _BOOKLIBRARY_LABEL_BUTTON_OWNERSLIST; ?>" class="button"/>
            </div>
        </form>
    <?php
    }
    
    static function showRentHistory($option, $rows, $pageNav, $params) {
        global $my, $Itemid,  $mosConfig_live_site, $mainframe, $booklibrary_configuration;
        $jinput = JFactory::getApplication()->input;
        $session = JFactory::getSession();
        // deprecated in Joomla 4.0 - Use JAccess directly:
        // $acl = JFactory::getACL(); 
        $acl = new JAccess;
        $arr = $session->get("array", "default");
        $doc = JFactory::getDocument();
        $doc->addStyleSheet($mosConfig_live_site . 
            '/components/com_booklibrary/includes/custom.css'); 
        $doc->addStyleSheet($mosConfig_live_site . '/components/com_booklibrary/includes/custom.css');
        if ($option == 'com_booklibrary') {
            // Get Current User 
            if (version_compare(JVERSION, "4.0.0", "ge")) {
                $app = JFactory::getApplication();
                $user = $app->getIdentity();
            } else {
                $user = Jfactory::getUser(); //old 09/2022
            }   
            $db = Jfactory::getDBO();
            $query = "SELECT * 
                      FROM #__booklibrary_lend_request AS b 
                      WHERE b.status=0";
            $db->setQuery($query);
            $current_user_rent_request_array = $db->loadObjectList();
            $check_for_show_rent_request = 0;
            if (isset($current_user_rent_request_array)) $check_for_show_rent_request = 1;
            
            $query = "SELECT id 
                      FROM #__booklibrary 
                      WHERE owner_id = '$user->id'";
            $db->setQuery($query);

            $userbooks = $db->loadObjectList();
            $querylend = "SELECT id 
                          FROM #__booklibrary_lend_request 
                          WHERE user_email = '$user->email' AND status=0";
            $db->setQuery($querylend);
            $userlendrequest = $db->loadObjectList();

            $query7 = "SELECT b.id 
                       FROM #__booklibrary AS b " . 
                      "LEFT JOIN #__booklibrary_lend AS l ON b.id=l.fk_bookid " . 
                      "WHERE user_email = '$user->email'";
            $db->setQuery($query7);
            $userlendhistory = $db->loadObjectList();
            
            

            if ($booklibrary_configuration['cb_mybook']['show'] == '1' && 
            checkAccessBL($booklibrary_configuration['cb_mybook']['registrationlevel'], 'NORECURSE', 
            userGID_BL($my->id), $acl) && (!empty($userbooks))) {
                $class = ($jinput->get('task','') == 'view_user_books')? 'active' : '' ;
                echo "<span class='books_button'><a class='".$class." my_btn my_btn-primary' href='" . 
                JRoute::_('index.php?option=' . $option . '&task=view_user_books&layout=mybooks&name='.$my->username."&Itemid=" . $Itemid) . "'>" . 
                    _BOOKLIBRARY_LABEL_CBBOOKS_TT . "</a></span>";
            }
            
            
            if (($booklibrary_configuration['cb_edit']['show']) == '1' && 
            checkAccessBL($booklibrary_configuration['cb_mybook']['registrationlevel'], 'NORECURSE', 
            userGID_BL($my->id), $acl)){
                $class = ($jinput->get('task','') == 'showmybooks')? 'active' : '' ;
                echo " <span class='books_button'><a class='".$class." my_btn my_btn-primary' href='" . 
                JRoute::_('index.php?option=' . $option . '&task=showmybooks&layout=mybooks&Itemid=' . $Itemid) . "'>" . 
                    _BOOKLIBRARY_LABEL_CBEDIT . "</a></span>";
            }
            
            
            
            if (($booklibrary_configuration['cb_history']['show'])) {
                $params->def('show_history', 1);
                $i = checkAccessBL($booklibrary_configuration['cb_history']['registrationlevel'], 
                    'NORECURSE', userGID_BL($my->id), $acl);
                if ($i) {
                    $params->def('show_history_registrationlevel', 1);
                }
                if ($params->get('show_history')) {
                    if ($params->get('show_history_registrationlevel')) {
                        if (!empty($userlendhistory)) {
                            $class = ($jinput->get('task','') == 'rent_history_books')? 'active' : '' ;
                            echo " <span class='books_button'>
                                     <a class='".$class." my_btn my_btn-primary' href='" . 
                                     JRoute::_('index.php?option=com_booklibrary&task=rent_history_books&name=' . 
                                        $user->name . '&user=' . $user->id . '&is_show_data=1&Itemid=' . $Itemid) . "'>" . 
                                        _BOOKLIBRARY_MY_LEND_HISTORY . "</a></span>";
                        }
                        
              /*echo "<div style=\" border:1px solid black; padding: 10px; 
                        text-align:center; \">you dont have rent_history_lable</div>";*/
                        
                    }
                }
            }
            
            if (($booklibrary_configuration['cb_rent']['show'])) {
                $params->def('show_rent', 1);
                $i = checkAccessBL($booklibrary_configuration['cb_rent']['registrationlevel'], 
                    'NORECURSE', userGID_BL($my->id), $acl);
                if ($i) {
                    $params->def('show_rent_registrationlevel', 1);
                }
                if ($params->get('show_rent')) {
                    if ($params->get('show_rent_registrationlevel')) {
                        if (!empty($userlendrequest)) {
                            $class = ($jinput->get('task','') == 'rent_requests_cb_books')? 'active' : '' ;
                            echo " <span class='books_button'><a class='".$class." my_btn my_btn-primary' href='" . 
                                JRoute::_('index.php?option=' . $option . 
                                '&task=rent_requests_cb_books&is_show_data=1Itemid=' . $Itemid) . "'>" . 
                                _BOOKLIBRARY_LEND_REQUESTS . "</a></span>";
                        }
                    }
                }
            }
        ?>
            <style type="text/css">
                .row0 {background-color:#F9F9F9;}
            </style><br/><br/><br/>

        <?php } ?>

        <?php
        //---------------------------------------------------------------------------- view
        /*echo " <span class='books_button'><a class='my_btn my_btn-primary' href='" . 
            JRoute::_('index.php?option=com_booklibrary&task=show_my_books&layout=mybooks') . "'>" . 
            BOOKLIBRARY_LABEL_CBBOOKS_TT . "</a></span>";*/
        
        ?>

        <?php if ($rows) { ?>
            <form class="g" action="index.php" method="get" name="adminForm" id="adminForm">
                <table cellpadding="4" cellspacing="0" border="0" width="100%" 
                       class="basictable my_table my_table-bordered
                        my_table-hover bl_all_categories_show_my_book_lend_history">
                    <tr>
                        <th align = "center" width="30">#</th>         
                        <th align = "center" class="title" width="5%" nowrap="nowrap">
                            <?php echo _BOOKLIBRARY_LABEL_BOOKID; ?></th>
                        <th align = "center" class="title" width="40%" nowrap="nowrap">
                            <?php echo _BOOKLIBRARY_LABEL_TITLE; ?></th>
                        <th align = "center" class="title" width="20%" nowrap="nowrap">
                            <?php echo _BOOKLIBRARY_ORDER_LEND_FROM; ?></th>
                        <th align = "center" class="title" width="20%" nowrap="nowrap">
                            <?php echo _BOOKLIBRARY_ORDER_LEND_UNTIL; ?></th>
                        <th align = "center" class="title" width="20%" nowrap="nowrap">
                            <?php echo _BOOKLIBRARY_SHOW_LEND_RETURN; ?></th>
                    </tr>


        <?php
            $numb = 0;
            //echo "<br/><pre>". print_r($rows,true)."</pre>";exit;
            for ($i = 0, $n = count($rows);$i < $n;$i++) {
                $row = $rows[$i];
                $book = $row->id;
                $title = $row->title;
                $numb++
        ?>
                        <tr>    
                            <td align="center">
                                <span class="hidename">#</span>
                                <?php echo $numb; ?>
                            </td>
                            <td align="center">
                                <span class="hidename"><?php echo _BOOKLIBRARY_LABEL_BOOKID; ?>:</span>
                                <?php echo $row->bookid; ?>
                            </td>
                            <td align="center">
                                <?php echo $row->title; ?>
                            </td>
                            <td align="center">
                                <span class="hidename"><?php echo _BOOKLIBRARY_ORDER_LEND_FROM; ?>:</span>
                                <?php echo $row->lend_from; ?>
                            </td>
                            <td align="center">
                                <span class="hidename"><?php echo _BOOKLIBRARY_ORDER_LEND_UNTIL; ?>:</span>
                                <?php echo $row->lend_until; ?>
                            </td>
                            <td align="center">
                                <span class="hidename"><?php echo _BOOKLIBRARY_SHOW_LEND_RETURN; ?>:</span>
                                <?php echo $row->lend_return; ?>
                            </td>
                        </tr>

        <?php } ?>

                    <tr class="for_paginator">
                        <td colspan="6" align="center" id="pagenavig">
                            <?php
                                $paginations = $arr;
                                if ($paginations && ($pageNav->total > $pageNav->limit)) 
                                    echo $pageNav->getPagesLinks();
                            ?>
                        </td>
                    </tr>
                </table>
            </form> 
        <?php
        } //else echo "<div style=\"text-align:center;\">HISTORY IS EMPTY</div>"
        
        ?>
    <?php
    }
    //------------------------------------------------------------------------------------------
    static function displayBookPrint(&$book, &$tabclass, &$params, &$currentcat) {
        // if ($book->published == 0) JError::raiseError(404, _BOOKLIBRARY_RESULT_NOT_FOUND);
        // JError deprecated Joomla 4.0 Just throw an Exception
        if ($book->published == 0) throw new Exception(_BOOKLIBRARY_RESULT_NOT_FOUND, 404);
        global $hide_js, $mainframe, $Itemid, $booklibrary_configuration, $mosConfig_live_site, 
               $mosConfig_absolute_path, $my;
        JPluginHelper::importPlugin('content');
        // Class 'JDispatcher' not found: JDispatcher deprecated J >= 4.0. Use JFactory::getApplication()->triggerEvent(...) instead
        // $dispatcher = JDispatcher::getInstance();
    ?>
    <head>
            <meta http-equiv="content-type" content="text/html; charset=utf-8" />
        </head>
        <body>
        <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
            <table class="basictable this7">
                <tr>
                    <td>
                    <?php
                        if (!$params->get('wrongitemid')) {
                            echo $currentcat->header;
                        } else {
                            $parametrs = $mainframe->getParams();
                            echo $parametrs->_registry['_default']['data']->page_title;
                        }
                    ?>
                    </td>
                    <td align="right">
                  
                            <a href="#" onclick="window.print();return false;">
                            <img src="<?php echo $mosConfig_live_site; ?>/media/system/images/printButton.png" alt="Print"  /></a>
                    
                    </td>
                </tr>  
            </table>
        </div>


        <table width="100%" cellpadding="4" cellspacing="0" border="0" align="center" 
               class="contentpane<?php echo $params->get('pageclass_sfx'); ?>">

        <?php if (trim($book->title)) { ?>
                <tr>
                    <td nowrap="nowrap" width="20%" align="right">       
                        <strong><?php echo _BOOKLIBRARY_LABEL_TITLE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
                        <?php echo $book->title; ?>
                    </td>
                </tr>

                <?php } ?>

            <tr>
                <td nowrap="nowrap" width="20%" align="right">
                    <strong><?php echo _BOOKLIBRARY_LABEL_BOOKID; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                    </strong>
                </td>
                <td>
                    <?php echo $book->bookid; ?>
                </td>
            </tr>
        <?php if (trim($book->authors)) { ?>

                <tr>
                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_AUTHORS; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
                    </td>
                    <td>
                        <?php echo $book->authors; ?>
                    </td>
                </tr>
        <?php }
            if (trim($book->isbn)) { 
        ?>


                <tr>

                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_ISBN; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
                        <?php echo $book->isbn; ?>
                    </td>
                </tr>   
        <?php
        }
            if (trim($book->manufacturer)) {
        ?>



                <tr>
                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_MANUFACTURER; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
                        <?php echo $book->manufacturer; ?>
                    </td>
                </tr>

        <?php
        }
            if (trim($book->edition)) {
        ?>



                <tr>
                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_EDITION; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
                        <?php echo $book->edition; ?>
                    </td>
                </tr>

        <?php
        }
            if ($book->numberOfPages != '') {
        ?>
                <tr>
                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_NUMPAGES; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
            <?php echo $book->numberOfPages; ?>
                    </td>
                </tr>
        <?php
        }
            if (trim($book->featured_clicks)) {
        ?>        
                <tr>
                    <td nowrap="nowrap" align="right" class="title_td">
                        <strong><?php echo _BOOKLIBRARY_LABEL_FEATURE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td align="left">
                        <?php echo $book->featured_clicks; ?>
                    </td>
                </tr>
        <?php
        }
            if (trim($book->featured_shows)) {
        ?>        
                <tr>
                    <td nowrap="nowrap" align="right" class="title_td">
                        <strong><?php echo _BOOKLIBRARY_LABEL_SHOWS; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td align="left">
                        <?php echo $book->featured_shows; ?>
                    </td>
                </tr>
        <?php
        }
            if (trim($book->language)) {
        ?>
                <tr>
                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_LANGUAGE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
                        <?php
                            echo $book->language; //old ENGLISH strtoupper($book->language);
            
                        ?>
                    </td>
                </tr>



        <?php
        }
            if ($params->get('show_price') == '1') {
        ?>
                <tr>
                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_PRICE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</strong>
                    </td>
                    <td>
            <?php echo $book->price; ?>&nbsp;&nbsp; <?php echo $book->priceunit; ?>

                    </td>
                </tr>
        <?php
        }
            if (trim($book->language)) {
        ?>
                <tr>
                    <td nowrap="nowrap" align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_RATING; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
                        <img src="<?php echo JURI::root(); ?>/components/com_booklibrary/images/rating-<?php 
                             echo $book->rating; ?>.png" 
                             alt="<?php echo ($book->rating) / 2; ?>" border="0" />&nbsp;
                    </td>
                </tr>

        <?php
        }
            if (trim($booklibrary_configuration['foto']['high']) || trim($book->imageURL)) {
        ?>
                <tr>
                    <td nowrap="nowrap" align="right" valign="top">
                        <strong><?php echo _BOOKLIBRARY_LABEL_PICTURE; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
        <?php
            //for local images
            $imageURL = $book->imageURL;
            if ($imageURL != '' && substr($imageURL, 0, 4) != "http") {
                $imageURL = $mosConfig_live_site  . $imageURL;
            }
            if ($imageURL != '') {
                echo '<img src="' . $imageURL . '" alt="cover" border="0" height="' . 
                    $booklibrary_configuration['foto']['high'] . '" width="' . 
                    $booklibrary_configuration['foto']['width'] . '"/>';
            } else {
                echo '<img src="' . $mosConfig_live_site . '/components/com_booklibrary/images/' . 
                    _BOOKLIBRARY_NO_PICTURE . '" alt="no-img_eng.png" border="0" />';
            }
        }
        ?>
                    <!--************   begin add button 'buy now'   ************************-->

        <?php
        //show button 'buy now'
        if ($params->get('show_input_buy_now') && $book->informationFrom == 1) {
            if ($book->URL != '') {
        ?>

                            &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;
                            <!--a href="<?php echo sefRelToAbs($mosConfig_live_site . 
                            "/index.php?option=com_booklibrary&amp;task=new_url&amp;id=" . 
                            $book->id); ?>" target="blank">
                                <img src="<?php echo JURI::root(); ?>
                                /components/com_booklibrary/images/amazon/buy_now.png" 
                                alt="Button Buy now" border="0" height="27" width="82" />
                            </a-->

        <?php
            }
        }
        ?>
                    <!--************************   end add button 'buy now'   ******************-->

                </td>
            </tr>

        <?php
        if ($params->get('show_emedisrequest') && $book->ebookURL != null) {
            $session = JFactory::getSession();
            $sid = $session->getId();
            $session->set("ssmid", $sid);
            setcookie('ssd', $sid, time() + 60 * 60 * 24, "/");
        ?>
                <tr>
                    <td align="right" >
                        <strong><?php echo _BOOKLIBRARY_LABEL_EMEDIA; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td align ="left">  
                        <a href="<?php 
                            echo sefRelToAbs('index.php?option=com_booklibrary&task=mdownload&id=' . 
                            $book->id); ?>" target="blank">
                            <?php echo _BOOKLIBRARY_LABEL_EMEDIA_DOWNLOAD; ?>
                        </a>
                    </td>
                </tr> 

        <?php  } ?>

        <?php
        //lend out??
        if ($params->get('show_lendstatus') && $params->get('show_lendrequest')) {
            $lend = $book->getAllLends();
            $num = count($lend);
            if ($num > 0) {
        ?>

                    <tr>
                        <td align="right" valign="top">
                            <strong><?php echo _BOOKLIBRARY_LABEL_LEND_FROM_UNTIL; ?>:</strong>
                        </td>
                        <td></td>
                    </tr>

        <?php
                for ($e = 0, $m = count($lend);$e < $m;$e++) {
                    print (" <tr><td align=\"left\">&nbsp;</td><td> ");
                    $date = substr($lend[$e]->lend_from, 0, 10) . "      " . 
                        substr($lend[$e]->lend_until, 0, 10);
                    print_r($date);
                    print (" </td></tr>");
                }
            }
        }
        if (trim($book->comment)) {
        ?>              
                <tr>
                    <td align="right" valign="top">
                        <strong><?php echo _BOOKLIBRARY_LABEL_COMMENT; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
        <?php
            $err_state = ini_get('display_errors');
            ini_set('display_errors', 'Off');
            $idesc = $book->comment; //load the desc into a variable
            $plug_row = new stdClass();
            $plug_row->text = $idesc; // load the var into plugin_row object
            // Class 'JDispatcher' not found: JDispatcher deprecated J >= 4.0. Use JFactory::getApplication()->triggerEvent(...) instead
            // $offset = 0;
            $plug_params = 1;
            // $results = $dispatcher->trigger('onContentPrepare', array('com_booklibrary', &$plug_row, &$plug_params, $offset)); //run mambot onPrepareContent on plug_row object
            // Trigger the onContentPrepare event.
            JFactory::getApplication()->triggerEvent('onContentPrepare', array("com_booklibrary", $plug_row, $plug_params));
            $idesc = $plug_row->text; //get new content from plug_row object to value
            echo $idesc; //echo new content out
            ini_set('display_errors', $err_state);
        ?>
                    </td>
                </tr>

        <?php } ?>

        <?php if ($book->owner_id != '' && $book->ownername != null && $booklibrary_configuration['owner']['show']) { ?>
                <tr>
                    <td align="right">
                        <strong><?php echo _BOOKLIBRARY_LABEL_BOOKOWNER; ?>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        </strong>
                    </td>
                    <td>
                        <?php echo $book->ownername; ?>
                    </td>
                </tr>

        <?php } ?>

            <tr>
                <td>&nbsp;</td>
                <td>&nbsp;</td>
            </tr> 
        </table>
        </body>
    <?php
      exit; // this exit needs to this function works correctly
        
    }

    /*****************************************************************/
        static function displayAuthorPrint(&$authors, $params, $rows, $author_description,$books_titles) {
            // if ($authors->published == 0) JError::raiseError(404, _BOOKLIBRARY_RESULT_NOT_FOUND);
            // JError deprecated Joomla 4.0 Just throw an Exception
            if ($authors->published == 0) throw new Exception(_BOOKLIBRARY_RESULT_NOT_FOUND, 404);
            global $hide_js, $mainframe, $Itemid, $booklibrary_configuration, $mosConfig_live_site, 
                   $mosConfig_absolute_path, $my;
            $jinput = JFactory::getApplication()->input;
            JPluginHelper::importPlugin('content');
            $printItem = $jinput->get('printItem');
            // Class 'JDispatcher' not found: JDispatcher deprecated J >= 4.0. Use JFactory::getApplication()->triggerEvent(...) instead
            // $dispatcher = JDispatcher::getInstance();
            ob_end_clean();
            ob_start();
        
    ?>
        <!---------------------------------------------------------------------------------->
        <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
            <table class="basictable this7">
                <tr>
                    <td>
                    </td>
                    <td align="right">
          
                            <a href="#" onclick="window.print();return false;">
                            <img src="<?php echo $mosConfig_live_site; ?>/media/system/images/printButton.png" alt="Print"  /></a>
                  
                    </td>
                </tr>  
            </table>
        </div>


        <?php
           HTML_booklibrary::displayAuthor($authors, $params, $rows, $author_description, $books_titles);
        ?>

    <?php
        
    }

    /*****************************************************************/


        static function listCategories(&$params, $cat_all, $catid, $tabclass, $currentcat,$layout="_one_item1") {
            global $Itemid, $mosConfig_live_site;
        ?>


        <?php
        }
        
        /*
        * function for show subcategory
        */
        static function showInsertSubCategory($id, $cat_all, $params, $tabclass, $Itemid, $deep,$layout="_one_item1") {
            global $g_item_count, $booklibrary_configuration, $mosConfig_live_site;

                //$layout = "_one_item1";
                $type = 'categories';
                require getLayoutPathBook::getLayoutPathCom('com_booklibrary', $type, $layout);
                /*require($mosConfig_absolute_path . 
                    "/components/com_booklibrary/views/categories/tmpl/" . $layout . ".php");*/
        }
        //end function showInsertSubCategory


            static function showSearchBooks($params, $currentcat, $clist, $option) {
                global $mosConfig_absolute_path, $booklibrary_configuration;
                $layout = $booklibrary_configuration['search_lay'];
                $type = 'show_search_book';
                require getLayoutPathBook::getLayoutPathCom('com_booklibrary', $type, $layout);
                /*require($mosConfig_absolute_path . 
                    "/components/com_booklibrary/views/show_search_book/tmpl/" . $layout . ".php");*/
                
            }

            static function showLendRequestThanks($params, $currentcat) {
                global $hide_js, $Itemid, $option;
            ?>
        <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
        <?php echo $currentcat->header; ?>
        </div>
        <table  class="basictable your_lend_request_was_stored" border="0" cellpadding="4" 
                cellspacing="0" width="100%">
            <tr>                
            <?php
                if ($currentcat->img != null) {
            ?>
                    <td>

                        <img src="<?php echo $currentcat->img; ?>" alt="?" />
                    </td>

                        <?php } ?>

                <td width="70%">
                    <?php echo $currentcat->descrip; ?>
                </td>

            </tr>
        </table>
        <form class="j" id="blForm" action="<?php echo sefRelToAbs("index.php?option=" . 
              $option . "&Itemid=" . $Itemid); ?>" 
              method="post" name="userForm">
            <table  class="basictable your_lend_request_was_stored_buttons" border="0" 
                    cellpadding="4" cellspacing="0" width="100%">
                <tr>
                    <td>
                        <input  type="hidden" name="task" value="view_book"  />
                        <input  type="hidden" name="id" value="<?php echo $_REQUEST['bookid']; ?>"  />
                        <input class="my_btn my_btn-success" type="submit" name="submit" 
                               value="<?php echo _BOOKLIBRARY_LABEL_OK; ?>" class="button" />
                    </td>
                </tr>

            </table>            
        </form>
        <?php
        }

        static function onlineBook($urlfliphtml5) { ?>
        
        
        <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
        <html>
          <head>
            <style>
                    body{
                    height:100%;
                    width:100%;
                }
                    html{
                    height:97%;
                    width:99%;
                    }
                </style>
            </head>

              <body>
                        <div style="width: 100%; height:100%;"> 
                      <iframe src="<?php echo $urlfliphtml5; ?>"
                      sandbox="allow-scripts" width=100% height=100%></iframe>
                </div> 
              </body>
         </html>

    <?php } 

    }    
?>
