 <?php
 /**
 *
 * @package BookLibrary
 * @copyright Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com);
 * Homepage: http://www.ordasoft.com
 * @version: 6.0 BookLibrary Free
 * @license GNU General Public license version 2 or later; see LICENSE.txt
 *
 */
if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . 
    basename(__FILE__) . ' is not allowed.');

use Joomla\Utilities\ArrayHelper;
global $option;
global $doc, $hide_js, $Itemid, $mosConfig_live_site, $mosConfig_absolute_path, $my, $database;
global $limit, $total, $limitstart, $Itemid, $task, $paginations, $mainframe, 
       $booklibrary_configuration;
$jinput = JFactory::getApplication()->input;

if(!isset($Itemid)) $Itemid = intval(mosGetParam($_REQUEST, 'Itemid', 0));


if ($cat_name != "") $category_url_part = "task=$cat_name";
else $category_url_part = "task=showCategory&amp;catid=$catid";
$session = JFactory::getSession();
$arr = $session->get("array", "default");
// deprecated in Joomla 4.0 - Use JAccess directly:
// $acl = JFactory::getACL(); 
$acl = new JAccess;

// Get Current User 
if (version_compare(JVERSION, "4.0.0", "ge")) {
    $app = JFactory::getApplication();
    $user = $app->getIdentity();
} else {
    $user = JFactory::getUser(); //old 09/2022
} 

$doc->addStyleSheet($mosConfig_live_site . '/components/com_booklibrary/includes/custom.css');

if( checkJavaScriptIncluded("jQuerBook-1.2.6.js") === false )   {
  $doc->addScript(JURI::root(true) . '/components/com_booklibrary/lightbox/js/jQuerBook-1.2.6.js');
} 
?>
<style type="text/css">
    .okno{width: <?php echo $booklibrary_configuration['foto']['width'] + 10; ?>px;}
    .okno img{width:<?php echo $booklibrary_configuration['foto']['width']; ?>px;
              max-height: <?php echo $booklibrary_configuration['foto']['high']; ?>px;}
    .okno .titlemedia{min-height:60px;}
</style> 
<script type="text/javascript">
    function lend_request_submitbutton_bl() {
        var form = document.userForm_bl;
        if (form.user_name.value == "") {
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_NAME; ?>" );
        } else if (form.user_email.value == "" || !isValidEmail(form.user_email.value)) {
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_EMAIL; ?>" );
        } else if (form.user_mailing == "") {       
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_MAILING; ?>" );
        } else if ((form.lend_until.value == "")  ) {
            alert( "<?php echo _BOOKLIBRARY_INFOTEXT_JS_LEND_REQ_UNTIL; ?>" );
        } else {
            form.submit();
        }
    }
    function isValidEmail(str) {
        return (str.indexOf("@") > 0);
    }
    
    function allreordering(){
        if(document.orderForm.direction.value=='asc')
            document.orderForm.direction.value='desc';
        else document.orderForm.direction.value='asc';

        document.orderForm.submit();
    }
</script>


    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
    

    <?php if ($params->get('show_page_heading') && $params->get('header') != "" ) {  ?>
                <h1><?php echo $params->get('header'); ?></h1>
    <?php } else {  ?>
                <h1><?php echo $currentcat->header;  ?></h1>                
    <?php } ?>

</div>

<table class="basictable bl_bl_books_gallery_top_table_with_icons" border="0" 
       cellpadding="4" cellspacing="0" width="100%">
    <tr>                
<?php 
if ($currentcat->img != null && $params->get('show_cat_pic') && false) { ?>
            <td>
                <img src="<?php echo $currentcat->img; ?>" align="<?php echo $currentcat->align; ?>" 
                     alt="booklibrary"/>
            </td>

<?php } ?>

 <td width="85%">
<?php
if (!$params->get('wrongitemid')) {
?>           
    <?php echo $currentcat->descrip;
    
} ?>
        </td>
    </tr>
</table>


    <?php
if (strpos($currentcat->header, _BOOKLIBRARY_LABEL_SEARCH) && count($rows) == 0) {
?>
    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
    <?php echo _BOOKLIBRARY_NOTHING_FOUND; ?>
    </div>
    <?php
    mosHTML::BackButton($params, $hide_js);
    return;
}
if ($params->get('show_search')) {
?>
    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
      <div  class="single_category_search">
    <?php
   
    if ($params->get('advsearch_show')) 
            echo '<div class="bl_bl_single_category_top_advanced_search my_btn my_btn-info">    
            <a href="' . JRoute::_('index.php?option=com_booklibrary&task=show_search&catid=0&Itemid=' . $Itemid ) . '">' . 
            _BOOKLIBRARY_ADMIN_CONFIG_ADVSEARCH . '</a></div>';
    if ($params->get('search_fieldshow')) echo HTML_booklibrary::displaySimpleSearch();
    ?>
      </div>
    </div>
<?php
}
$total = count($rows);
if ($total > 0) {
    $sort_arr['field'] = $params->get('sort_arr_field');
    $sort_arr['direction'] = $params->get('sort_arr_direction');
?>
    
    <?php if ($jinput->get('option') != "com_simplemembership") { ?>
    <table width="100%" class="basictable bl_bl_books_orderby_table">
        <tr>
            <?php
            // JArrayHelper deprecated 4.0 Use Joomla\Utilities\ArrayHelper instead (ArrayHelper since J 1.0)
            // $option_type = JArrayHelper::getValue($_REQUEST, 'option');
            $option_type = ArrayHelper::getValue($_REQUEST, 'option');
            if ($option_type != 'com_simplemembership') { ?> 
                <td >
                    <div id="ShowOrderBy" style="text-align:right" >

                        <form class="bl_bl_books_gallery_sort_by" id="adminForm" method="POST" 
                              action="<?php echo sefRelToAbs($_SERVER["REQUEST_URI"]); ?>" 
                              name="orderForm">
                            <input type="hidden" id="direction" name="direction" 
                                   value="<?php echo $sort_arr['direction']; ?>" >
                            <a title="Click to sort by this column." 
                               onclick="javascript:allreordering();return false;" href="#">
                                <img alt="" src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/sort_<?php
            if ($sort_arr['direction'] == false) {
                echo 'asc';
            } else {
                echo $sort_arr['direction'];
            } ?>.png" />
                            </a>
            <?php echo _BOOKLIBRARY_LABEL_ORDER_BY; ?> <select size="1" class="inputbox" 
                  onchange="javascript:document.orderForm.direction.value='asc'; 
                  document.orderForm.submit();" id="field" name="field">
          <option value="authors" <?php if ($sort_arr['field'] == "authors") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_AUTHORS; ?></option>
          <option value="title" <?php if ($sort_arr['field'] == "title") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_TITLE; ?></option>
          <option value="rating" <?php if ($sort_arr['field'] == "rating") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_RATING; ?></option>
          <option value="hits" <?php if ($sort_arr['field'] == "hits") echo 'selected="selected"'; ?> > 
            <?php echo _BOOKLIBRARY_LABEL_HITS; ?></option>
      </select>       
                        </form>
                    </div>
                </td>

        <?php } ?> 

        </tr>
    </table> 

    <?php } ?>


    <?php
        $available = false;
    ?>

    <div id="gallery">
        <table  width="100%" border="0" cellspacing="0" cellpadding="0">
    <?php
    $total = count($rows);
    foreach($rows as $row) {
        $cat_id = @(isset($row->category_id)) ? $row->category_id : $catid;
        $link = 'index.php?option=' . $option . 
                '&task=view_bl&tab=getmybooksTab&is_show_data=1&id=' . $row->id . 
                '&catid=' . $cat_id . '&Itemid=' . $Itemid;
        $imageURL = $row->imageURL;
    ?>

                <div class="okno" style="position:relative">
                    
                    <div>
                        <a href="<?php echo sefRelToAbs($link); ?>" >
                        <?php
                        if ($imageURL != '') {
                            if ($imageURL != '' && substr($imageURL, 0, 4) != "http") {
                                $imageURL = $mosConfig_live_site . '' . $imageURL;;
                            }
                            echo '<img height="' . $booklibrary_configuration['foto']['high'] . '"
                                                      width="' . $booklibrary_configuration['foto']['width'] . 
                                                      ' "src="' . $imageURL . '" border="0">';
                        } else {
                            echo '<img  height="' . $booklibrary_configuration['foto']['high'] . '"
                                                      width="' . $booklibrary_configuration['foto']['width'] . 
                                                      '" src="' . './components/com_booklibrary/images/' . 
                                                      _BOOKLIBRARY_NO_PICTURE . 
                                                      '" alt="no-img_eng_big.png" border="0"  />';
                        }
                        ?>
                        </a>
                    </div>
                    <div class="textmedia">
                        <div class="titlemedia">
                            <a href="<?php echo sefRelToAbs($link); ?>" >
                            <?php
                                if (mb_strlen($row->title) > 30) echo mb_substr($row->title, 0, 30), '...';
                                else {
                                    echo $row->title;
                                }
                            ?>
                            </a>
                        </div>
                        <div class="authors">
                        <?php
                            if (mb_strlen($row->authors) > 15) echo mb_substr($row->authors, 0, 15), '...';
                            else {
                                echo $row->authors;
                            }
                        ?>
                        </div>
                    </div>

                </div>

                <?php } ?>


        </table>
    </div>
    <br />
    <?php //show index for field authors,title
        if ($sort_arr['field'] == "authors" || $sort_arr['field'] == "title") {
    ?>
            <div id="paginator-custom-index">    
            <?php
                //print_r($sort_arr);
                foreach($list_str as $a) {
                    echo $a;
                }
            ?>
            </div>    
    <?php
    } // close show index
    ?>

    <?php } ?>
            <div id="paginator-custom">
    <?php
    if ($pageNav != null && $pageNav->total > $pageNav->limit) {
        echo $pageNav->getPagesLinks(); 
    }
    ?>
            </div>

<?php
if ($params->get('show_lendstatus') && $params->get('show_lendrequest') 
    && $params->get('lend_save')) {
?>

    <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
                    <?php echo _BOOKLIBRARY_LABEL_LEND_INFORMATIONS; ?>
    </div>
    <form class="t" id="adminForm_bl" action="<?php echo sefRelToAbs("index.php"); ?>" 
          name="userForm_bl" method="post">
        <table  class="basictable this38" width="100%" border="0" cellspacing="0" cellpadding="0">            
            <tr>
                <td colspan="2">&nbsp;</td>
            </tr>

            <tr>
                <td>
    <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_NAME;
    global $my;
?>:<br />
          <input type="hidden"  name="bookid" id="bookid"  value="<?php echo $row->id ?>"  
                 maxlength="80" />
          <input class="inputbox" type="text" name="user_name" size="38"
                 maxlength="80" value="<?php if ($my->name != '') echo $my->name ?>" />       
          <input type="hidden" name="option" value="<?php echo $option; ?>"/>
          <input type="hidden" name="task" value="save_lend_request_bl"/>
          <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>"/>
          <input type="hidden" name="bookid" value="<?php echo $rows[0]->id; ?>"/>
          <input type="hidden" name="bid[]" value="<?php echo $rows[0]->id; ?>"/>
             </td>
             <td>
                <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_EMAIL; ?>:<br />
                    <input class="inputbox" type="text" name="user_email" size="38" maxlength="80" 
                           value="<?php if ($my->name != '') echo $my->email ?>"/>
                </td>
            </tr>
            <tr>
                <td colspan="2">&nbsp;</td>
            </tr>
        </table>                                      

        <script>
            Date.prototype.toLocaleFormat = function(format) {
                var f = {Y : this.getYear() + 1900,m : this.getMonth() +
                  1,d : this.getDate(),H : this.getHours(),M : this.getMinutes(),S : this.getSeconds()}
                for(k in f)
                    format = format.replace('%' + k, f[k] < 10 ? "0" + f[k] : f[k]);
                return format;
            };

                        
            window.onload = function ()
            {
                var today = new Date();
                var date = today.toLocaleFormat("<?php echo $booklibrary_configuration['date_format'] ?>");
                document.getElementById('lend_from').value = date;
                document.getElementById('lend_until').value = date;
            }; 

        </script>

        <table  class="basictable this39" width="100%" border="0" cellspacing="0" cellpadding="0">              
            <tr>
                <td>
    <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_MAILING; ?>:<br />         

                    <!--editorArea( 'editor1',  '' , 'user_mailing', '400', '200', '30', '5' ) ;-->       

                    <textarea align= "top" name="user_mailing" id="user_mailing" cols="60" rows="10" 
                              style="width:400;height:100;" 
                              value="<?php // if ( isset($_REQUEST["comment"]) ) {echo $_REQUEST["comment"];}?>"/>
                    </textarea>                
                </td>
                <td>
                    <br />
                    <p>
                        <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_FROM; ?>:<br />

                        <?php 
                        echo JHtml::_('calendar', date("Y-m-d"), 'lend_from', 'lend_from', 
                            $booklibrary_configuration['date_format']); ?>
                    </p>
                    <p>
                        <?php echo _BOOKLIBRARY_LABEL_LEND_REQUEST_UNTIL; ?>:<br />

                        <?php 
                        echo JHtml::_('calendar', date("Y-m-d"), 'lend_until', 'lend_until', 
                        $booklibrary_configuration['date_format']); ?>
                    </p>
                </td>
            </tr>
        </table>
              <input type="button" class="button" 
                     value="<?php echo _BOOKLIBRARY_LABEL_BUTTON_LEND_REQU_SAVE; ?>" 
                     onclick="lend_request_submitbutton_bl()" />
       </form> 

        <?php } ?>



    <?php

    if ($is_exist_sub_categories) {
    ?>            
        <div class="componentheading<?php echo $params->get('pageclass_sfx'); ?>">
        <?php echo _BOOKLIBRARY_LABEL_FETCHED_SUBCATEGORIES . " : " . $params->get('category_name'); ?>
        </div>
        <?php
        //HTML_booklibrary::listCategories($params, $categories, $catid, $tabclass, $currentcat,$layout="_one_item1");
     ?>
        <div class="bl_bl_single_category_list_categories_table my_table-bordered show_categories_wrapper">
        <?php
            $show_subcat_class = "all_categories_new" ;
            if(!isset($one_item_layout) || $one_item_layout == "_one_item1" ){
                $show_subcat_class = "" ;

        ?>

            <div class="show_categories_wrapper_title">
                <div class="sectiontableheader sectiontableheader_category<?php echo $params->get('pageclass_sfx'); ?>">
        <?php echo _BOOKLIBRARY_LABEL_CATEGORY; ?>
                </div>
                <div class="sectiontableheader sectiontableheader_books<?php echo $params->get('pageclass_sfx'); ?>">
                <?php echo _BOOKLIBRARY_LABEL_BOOKS; ?> 
                </div>


                <div class="sectiontableheader sectiontableheader_rss" style="text-align:center;">
                <?php
                    $Itemid = intval(mosGetParam($_REQUEST, 'Itemid', 0));
                ?>
                        <?php  
              if ($params->get('rss_show')){ ?>
                        <a href="<?php echo $mosConfig_live_site; ?>/index.php?option=com_booklibrary&task=show_rss_categories&Itemid=<?php 
                            echo $Itemid; ?>">
                            <img src="<?php echo $mosConfig_live_site; ?>/components/com_booklibrary/images/rss.gif" 
                                 alt="All categories RSS" title="All categories RSS"/>
                        </a>
                        <?php } ?>
                </div>

                
            </div>
        <?php
            }

        ?>
                
            <div class="show_categories_list_wrapper <?php echo  $show_subcat_class; ?>">
                <div>
                    <?php
                        HTML_booklibrary::showInsertSubCategory($catid, $categories, $params, $tabclass, 
                                                                $Itemid, 0,$one_item_layout);
                    ?>
                </div>
            </div>
        </div>


    <?php        
    }
    echo '<table  class="basictable bl_bl_single_category_intresting_back_button" 
        width="100%"><tr><td width="60%"></td><td>';
    mosHTML::BackButton($params, $hide_js);
    echo '</td></tr></table>';
?>


<!-- Modal -->
<a href="#aboutus" class="book-button-about"></a>
                    
<a href="#book-modal-css" class="book-overlay" id="book-aboutus" style="display: none;"></a>
<div class="book-popup">
    <div class="book-modal-text">
        Please past text to modal
    </div>
     
    <a class="book-close" title="Close" href="#book-close"></a>
</div>
<div style="text-align: center;font-size: 10px;"><a href="https://ordasoft.com/book-library" >Book Library</a>, by OrdaSoft!</div>
